/*
 * Copy.java
 *
 * Created on 10. duben 2002, 12:41
 */

package SOFA.Connector.EEG.fileutil;

/**
 *
 * @author  ghort
 * @version 
 */
public class Copy {

	/** Creates new Copy */
	private Copy() {
	}

	public static void copy(java.io.File destination, java.io.File source) throws CopyException {
		if (source.isDirectory()) {
			if (!destination.isDirectory()) {
				throw new CopyException("Destination '"+destination.getName()+"' is not directory.");
			}
			copyDirectory(destination,source);
		} else {
			if (destination.isDirectory()) {
				destination=new java.io.File(destination,source.getName());
			}
			copyFile(destination,source);
		}
	}
	
	protected static void copyDirectory(java.io.File destination, java.io.File source) throws CopyException {
		java.io.File[] list=source.listFiles();
		for (int i=0;i<list.length;i++) {
			java.io.File dest=new java.io.File(destination,list[i].getName());
			if (list[i].isDirectory()) {
				dest.mkdir();
				copyDirectory(dest,list[i]);
			} else {
				copyFile(dest,list[i]);
			}
		}
	}
	
	protected static void copyFile(java.io.File destination, java.io.File source) throws CopyException {
		try {
			java.io.FileInputStream inStream=new java.io.FileInputStream(source);
			java.io.FileOutputStream outStream=new java.io.FileOutputStream(destination);

			int len;
			byte[] buf=new byte[2048];
			 
			while ((len=inStream.read(buf))!=-1) {
				outStream.write(buf,0,len);
			}
		} catch (Exception e) {
			throw new CopyException("Can't copy file "+source+" -> "+destination+".",e);
		}
	}
}
