/* $Id: CompInst.java,v 2.6 2002/12/09 22:33:07 hnetynka Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;
 
class CompInst extends CompContainedIm {
  public static final int normal = 0;
  public static final int auto = 1;
  CompReffer subcom;
  int mode;
  String typeCode;
  
  String protocol;  // rewritten protocol of frame
  java.util.ArrayList provOps;  // list of provide's operations (contains provIfaceOperations)
  
  public CompInst(ID id, CompContainer parent, CompRepository rep, CompReffer subcom, int mode, String tC) {
    super(ObjectsKind.o_Inst, id, parent, rep);
    id.version = ((CompContained)parent).getIdent().version;
    this.mode = mode;
    this.subcom = subcom;
    typeCode = tC;
    protocol = null;
    provOps = new java.util.ArrayList();
  }

  public boolean containsArray() {
    if (typeCode.indexOf('a')!=-1)
      return true;
    return false;
  }

  public static CompReffer canBeInst(FullID idp, EnumList propNames, CompRepository inRep, StringBuffer typeCode) throws CDLExceptLock, CDLExceptRemote {
    CompReffer what = null;
    if ((what = inRep.searchReffer(idp))==null) {
      return null;
    }  
    if (System.getProperty("cdl.disableBindTests","no").compareTo("yes")==0) {
      return what;
    }
    // test if "what" is iface or array of ifaces
    boolean ok = false;
    int kind = what.what;
    CompReffer r = what;
    while (!ok) {
      if (kind != ObjectsKind.o_Frame) {
        if (kind == ObjectsKind.o_Typedef || kind == ObjectsKind.o_Array) {
          int i,j;
          FullID id = r.ref;
          if (r.isNew) {  // in actually added objects
            CompContainer con = inRep;
            id.sn.names.toFirst();
            for(i=0;i<id.sn.names.size();i++) {
              CompContained[] a = con.lookup((String) id.sn.names.aktual());
              if (a==null || a.length==0) {
                inRep.searchError = "this can't be instantion";
                return null;
              }  
              if (a.length==1) {
                if (a[0].isContainer()) con = (CompContainer) a[0];
                else {
                  inRep.searchError = "this can't be instantion";
                  return null;
                }  
              } else {
                inRep.searchError = "this can't be instantion";
                return null;
              }
              id.sn.names.toNext();
            }
            CompContained sec = con.lookup(id.name, id.version);
            if (sec!=null) {
              CompType sectype = null;
              if (sec.objectKind() == ObjectsKind.o_Typedef)
                sectype = ((CompTypedef) sec).type;
              else
                sectype = ((CompArray) sec).type;
              if (sectype.objectKind() != ObjectsKind.o_Frame) {
                if (sectype.objectKind()==ObjectsKind.o_none) { // is CompReffer
                  r = (CompReffer) sectype;
                  kind = r.what;
                } else {
                  if (sectype.objectKind()==ObjectsKind.o_Array) {
                    while (sectype.objectKind()==ObjectsKind.o_Array) {
                       typeCode.append('a');
                       // test property in array length
                       EnumList exprProp = ((CompArray) sectype).length.nameProp(inRep);
                       if (!CompExprOper.testPropInExpr(propNames,exprProp)) {
                         inRep.searchError = "unknown property";
                         return null;
                       }
                       sectype = ((CompArray) sectype).type;
                    }
                    if (sectype.objectKind() != ObjectsKind.o_none) {
                      if (sectype.objectKind() == ObjectsKind.o_Frame) {
                        typeCode.append('f');
                        //operNames = ((CompInterface) sectype).operationNames();
                        ok = true;
                      } else {
                        inRep.searchError = "this can't be instantion";
                        return null;
                      }  
                    } else {
                      r = (CompReffer) sectype;
                      kind = r.what;
                    }
                  } else {
                    inRep.searchError = "this can't be instantion";
                    return null;
                  }
                }  
              } else {
                typeCode.append('f');
                //operNames = ((CompInterface) sectype).operationNames();
                ok = true;
              }
            } else {
              inRep.searchError = "this can't be instantion";
              return null;
            }  
          } else {  // in normal repository
            try {
              Container con = inRep.cdlRepository;
              id.sn.names.toFirst();
              for(i=0;i<id.sn.names.size();i++) {
                Contained[] a = con.lookup_name((String) id.sn.names.aktual());
                if (a==null || a.length==0) {
                  inRep.searchError = "this can't be instantion";
                  return null;
                }  
                if (a.length==1) {
                  if (a[0] instanceof Container) con = (Container) a[0];
                  else {
                    inRep.searchError = "this can't be instantion";
                    return null;
                  }  
                } else {
                  boolean found = false;
                  for(j=0;j<a.length;j++) {
                    if (a[j].get_identification().version().compareTo(id.version)==0) {
                      if ( !(a[j] instanceof Container)) {
                        inRep.searchError = "this can't be instantion";
                        return null;
                      }  
                      found = true;
                      con = (Container) a[j];
                      break;
                    }
                  }
                  if (!found) {
                    inRep.searchError = "this can't be instantion";
                    return null;
                  }
                }
                id.sn.names.toNext();
              }
              Contained sec = con.lookup(id.name, id.version);
              if (sec!=null) {
                CDLType sectype = null;
                if (sec.get_def_kind().value() == DefinitionKind.dk_Typedef)
                  sectype = ((TypedefDef) sec).original_type();
                else
                  sectype = ((ArrayDef) sec).element_type();
                if (sectype.get_def_kind().value() != DefinitionKind.dk_Frame) {
                  if (sectype.get_def_kind().value() == DefinitionKind.dk_Typedef) {
                    CompReffer ret = new CompReffer();
                    ret.what = sectype.get_def_kind().value();
                    ret.ref = new FullID(true);
                    Identification idl;
                    ret.ref.name = new String((idl = ((TypedefDef)sectype).get_identification()).name());
                    ret.ref.version = new String(idl.version());
                    ret.ref.isin = IDKind.version;
                    ret.isNew = false;
                    AbsoluteName abs = idl.absolute_name();
                    for(j=0;j<abs.size();j++) {
                      ret.ref.sn.addScope(new String(abs.elementAt(j)));
                    }
                    r = ret;
                    kind = r.what;
                  } else {
                    if (sectype.get_def_kind().value()==DefinitionKind.dk_Array) {
                      while (sectype.get_def_kind().value()==DefinitionKind.dk_Array) {
                        typeCode.append('a');
                        // test property in array length
                        EnumList exprProp = CompExprOper.scanNormalExpr(((ArrayDef) sectype).length());
                        if (!CompExprOper.testPropInExpr(propNames,exprProp)) {
                          inRep.searchError = "unknown property";
                          return null;
                        }
                        sectype = ((ArrayDef) sectype).element_type();
                      }
                      if (sectype.get_def_kind().value()!=DefinitionKind.dk_Typedef) {
                        if (sectype.get_def_kind().value()==DefinitionKind.dk_Frame) {
                          typeCode.append('f');
                          ok = true;
                        } else { 
                          inRep.searchError = "this can't be instantion";
                          return null;
                        }
                      } else {
                        CompReffer ret = new CompReffer();
                        ret.what = sectype.get_def_kind().value();
                        ret.ref = new FullID(true);
                        Identification idl;
                        ret.ref.name = new String((idl = ((TypedefDef)sectype).get_identification()).name());
                        ret.ref.version = new String(idl.version());
                        ret.ref.isin = IDKind.version;
                        ret.isNew = false;
                        AbsoluteName abs = idl.absolute_name();
                        for(j=0;j<abs.size();j++) {
                          ret.ref.sn.addScope(new String(abs.elementAt(j)));
                        }
                        r = ret;
                        kind = r.what;   
                      }
                    } else {
                      inRep.searchError = "this can't be instantion";
                      return null;
                    }
                  }  
                } else {
                  typeCode.append('f');
                  ok = true;
                }
              } else {
                inRep.searchError = "this can't be instantion";
                return null;
              }
            } catch (TIRExceptLock e) {
              throw new CDLExceptLock("Repository is locked.");
            } catch (RemoteException e) {
              throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
            }
          }
        } else {
          inRep.searchError = "this can't be instantion";
          return null;
        }
      } else {
        typeCode.append('f');
        ok = true;
      }
    } 
    return what;
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    subcom.checkConsist(props, rep);
    if (rep.testProtocols) {
      //Output.out.println("\033[33mArchitecture: "+((CompContained)parent()).getIdent()+":"+getIdent().name+"\033[37m");
      //Debug.message(generateArchProtocol());

      // this is called from architecture
      // protocol = generateArchProtocol();
    }
  }

  static class reProvReq {
    String origSub;
    String origName;
    String rew;
    int type;
    public reProvReq(String os, String on, int t) {
      origSub = os;
      origName = on;
      type = t;
    }
    
    public boolean compareTo(String s, String n) {
      if (origSub.compareTo(s)==0 && origName.compareTo(n)==0)
        return true;
      return false;
    }

    public String toString() {
      return origSub+"."+origName+"("+rew+")";
    }
  }

  // for provOps list 
  static class provIfaceOperations {
    String   sub;
    String   provide;   // name of provision
    String   rew;
    String[] operations;
    public provIfaceOperations(String s, String p, String[] op) {
      sub = s;
      provide = p;
      operations = op;
    }
    public String toString() {
      StringBuffer sb = new StringBuffer();
      for (int i=0;i<operations.length;i++) {
        sb.append(rew+"."+operations[i]+", ");
      }
      return sb.toString();
    }
    public boolean compareTo(String s, String p) {
      return s.compareTo(sub)==0 && p.compareTo(provide)==0;
    }
    public String[] toRewOperations() {
      String[] ret = new String [operations.length];
      for (int i=0; i<ret.length;i++) {
        ret[i] = rew+"."+operations[i];
      }
      return ret;
    }
  }

  public String generateArchProtocol(DetectedConnectors dc) throws CDLExceptLock, CDLExceptRemote {
    int i,j;
    /*
    if (containsArray()) {
      if (rep.testProtocols) {
        rep.testProtocols = false;
        Output.out.println("Warning: Turning tests of protocols off");
      }
      return null;
    }*/
    if (subcom.isNew) {
      CompFrame fr = (CompFrame) getInstFrame(subcom, repository()).getRefferedObject(repository());
      java.util.ArrayList provReq = new java.util.ArrayList();
      CompContained[] cont = fr.contents();
      for (i=0;i<cont.length;i++) {
        if (cont[i].objectKind() == ObjectsKind.o_Provides) {
          /*if (((CompProvide)cont[i]).typeCode.indexOf('a')!= -1) {
            return null;
          }*/
          provReq.add(new reProvReq(new String(this.getIdent().name), new String(cont[i].getIdent().name), ObjectsKind.o_Provides));
          //provOps.add( new provIfaceOperations(new String(this.getIdent().name), new String(cont[i].getIdent().name),((CompProvide)cont[i]).operations.toArray() ) );
        }
        if (cont[i].objectKind() == ObjectsKind.o_Requires) {
          /*if (((CompRequire)cont[i]).typeCode.indexOf('a')!= -1) {
            return null;
          }*/
          provReq.add(new reProvReq(new String(this.getIdent().name), new String(cont[i].getIdent().name), ObjectsKind.o_Requires));
        }
      }
      //rewriteProt(provReq, provOps);
      rewriteProt(provReq, dc);
      return compFrameProtToArch(fr.protocol, provReq);
    } else {
      try {
        FrameDef fr = (FrameDef) getInstFrame(subcom, repository()).getRefferedObject(repository());
        ProtocolDef protocol = fr.protocol();
        if (protocol == null)
          return "";
        java.util.ArrayList provReq = new java.util.ArrayList();
        Contained[] contRep = fr.contents(null);
        for (i=0;i<contRep.length;i++) {
          if (contRep[i].get_def_kind().value() == DefinitionKind.dk_Provides) {
            provReq.add(new reProvReq(new String(this.getIdent().name), new String(contRep[i].get_identification().name()), DefinitionKind.dk_Provides));
            //provOps.add( new provIfaceOperations(new String(this.getIdent().name), new String(contRep[i].get_identification().name()),getNormFrameProvideOperations((ProvideDef)contRep[i], repository()) ) );
          }
          if (contRep[i].get_def_kind().value() == DefinitionKind.dk_Requires) {
            provReq.add(new reProvReq(new String(this.getIdent().name), new String(contRep[i].get_identification().name()), DefinitionKind.dk_Requires));
          }
        }
        //rewriteProt(provReq, provOps);
        rewriteProt(provReq, dc);
        return normFrameProtToArch(protocol.protocol(), provReq);
      } catch (RemoteException e) {
        throw new CDLExceptRemote(e.getMessage());
      } catch (TIRExceptLock e) {
        throw new CDLExceptLock(e.getMessage());
      }
    }
  }

//  void rewriteProt(java.util.ArrayList provReq, java.util.ArrayList provOps) {
  void rewriteProt(java.util.ArrayList provReq, DetectedConnectors dc) {
    int i,j;
    CompContained[] cont = parent().contents();
    for(i=0;i<cont.length;i++) {
      if (cont[i].objectKind() == ObjectsKind.o_Bind) {
        CompBind bind = (CompBind) cont[i];
        String r1, r2, l1, l2;
        int index;
        DetectedConnector cn;
        switch (bind.mode) {
          case CompBind.m_delegate:
            cn = dc.containsConnWithSRole(bind.rhs);
            bind.rhs.subs.toFirst(); bind.rhs.elements.toFirst();
            r1 = ((CompBindType) bind.rhs.subs.aktual()).name;
            r2 = ((CompBindType) bind.rhs.elements.aktual()).name;
            for (j=0;j<provReq.size();j++) {
              if ( ((reProvReq)provReq.get(j)).compareTo(r1,r2) ) {
                bind.lhs.elements.toFirst();
                l1 = ((CompBindType) bind.lhs.elements.aktual()).name;
                ((reProvReq)(provReq.get(j))).rew = "<"+l1+"-"+r1+":"+r2+">"; 
                /*((reProvReq)(provReq.get(j))).rew = "<sRole-"+r1+":"+r2+">";*/
                break;
              }
            }
            break;
          case CompBind.m_subsume:
            cn = dc.containsConnWithSRole(bind.rhs);
            index = cn.indexOfCRole(bind.lhs);
            bind.lhs.subs.toFirst(); bind.lhs.elements.toFirst();
            l1 = ((CompBindType) bind.lhs.subs.aktual()).name;
            l2 = ((CompBindType) bind.lhs.elements.aktual()).name;
            for (j=0;j<provReq.size();j++) {
              if ( ((reProvReq)provReq.get(j)).compareTo(l1,l2) ) {
                bind.rhs.elements.toFirst();
                r1 = ((CompBindType) bind.rhs.elements.aktual()).name;
                ((reProvReq)(provReq.get(j))).rew = "<"+l1+":"+l2+"-"+r1+">"; 
               /* ((reProvReq)(provReq.get(j))).rew = "<"+l1+":"+l2+"-cRole"+Integer.toString(index)+">"; */
                break;
              }
            }
            break;
          case CompBind.m_bind:
            if (bind.rhs.kind==CompBindOper.b_sub && bind.lhs.kind==CompBindOper.b_sub) {
              cn = dc.containsConnWithSRole(bind.rhs);
              index = cn.indexOfCRole(bind.lhs);
              bind.lhs.subs.toFirst(); bind.lhs.elements.toFirst();
              l1 = ((CompBindType) bind.lhs.subs.aktual()).name;
              l2 = ((CompBindType) bind.lhs.elements.aktual()).name;
              bind.rhs.subs.toFirst(); bind.rhs.elements.toFirst();
              r1 = ((CompBindType) bind.rhs.subs.aktual()).name;
              r2 = ((CompBindType) bind.rhs.elements.aktual()).name;
              for (j=0;j<provReq.size();j++) {
            //    Debug.message(provReq.get(j)+" - "+l1+"."+l2+":"+r1+"."+r2);
     /*           if ( ((reProvReq) provReq.get(j)).compareTo(l1,l2) || ((reProvReq) provReq.get(j)).compareTo(r1,r2) ) {
                  ((reProvReq)(provReq.get(j))).rew = "<"+l1+":"+l2+"-"+r1+":"+r2+">";
                  for (int k=0;k<provOps.size();k++) {
                     if (((provIfaceOperations)provOps.get(k)).compareTo(l1,l2) || ((provIfaceOperations)provOps.get(k)).compareTo(r1,r2)) {
                       ((provIfaceOperations)provOps.get(k)).rew = "<"+l1+":"+l2+"-"+r1+":"+r2+">";
                     }
                  }
                }  */
                if (((reProvReq) provReq.get(j)).compareTo(l1,l2)  && ((reProvReq) provReq.get(j)).type==ObjectsKind.o_Requires ) {
                  ((reProvReq)(provReq.get(j))).rew = "<"+l1+":"+l2+"-cRole"+Integer.toString(index)+">";
                }
                if (((reProvReq) provReq.get(j)).compareTo(r1,r2)  && ((reProvReq) provReq.get(j)).type==ObjectsKind.o_Provides ) {
                  ((reProvReq)(provReq.get(j))).rew = "<sRole0-"+r1+":"+r2+">";
                }
              }
            }
            break;
        } //-- end of switch
      }
    } //-- end of for
  }

  public static String compFrameProtToArch(CompProtOper p, java.util.ArrayList names) {
    StringBuffer sb = new StringBuffer();
    int i;
    switch (p.type) {
    case CompProtKind.p_operand:
      CompProtOperand op = (CompProtOperand) p;
      if (op.mode == CompProtMode.pm_in)
        sb.append("?");
      else
        sb.append("!");
      for (i=0;i<names.size();i++) {
        if ( op.ifacename.compareTo(((reProvReq)(names.get(i))).origName) == 0 ) {
          if (((reProvReq)(names.get(i))).rew != null)
            sb.append(((reProvReq)(names.get(i))).rew);
          else 
            sb.append("<"+((reProvReq)(names.get(i))).origName+">");
        }
      }
      sb.append(".");
      sb.append(((CompProtOperand) p).operand);
      break;
    case CompProtKind.p_nulloperand:
      sb.append("NULL");
      break;
    case CompProtKind.p_metaoperand:
      sb.append("[");
      sb.append(((CompProtMetaOperand) p).name);
      sb.append("]");
      break;
    case CompProtKind.p_nestedoperand:
      CompProtNestedOperand nop = (CompProtNestedOperand) p;
      if (nop.mode == CompProtMode.pm_in)
        sb.append("?");
      else
        sb.append("!");
      for (i=0;i<names.size();i++) {
        if ( nop.ifacename.compareTo(((reProvReq)(names.get(i))).origName) == 0 ) {
          if (((reProvReq)(names.get(i))).rew != null)
            sb.append(((reProvReq)(names.get(i))).rew);
          else 
            sb.append("<"+((reProvReq)(names.get(i))).origName+">");
          break;
        }
      }
      sb.append(".");
      sb.append(nop.operand);
      sb.append("{");
      sb.append(compFrameProtToArch(nop.nestOperand, names));
      sb.append("}");
      break;
    case CompProtKind.p_repetition:
      sb.append("(");
      sb.append(compFrameProtToArch(((CompProtUnOper) p).operand, names));
      sb.append(")*");
      break;
    case CompProtKind.p_andparallel:
      sb.append("(");
      sb.append(compFrameProtToArch(((CompProtBinOper) p).operand1, names));
      sb.append(")|(");
      sb.append(compFrameProtToArch(((CompProtBinOper) p).operand2, names));
      sb.append(")");
      break;
    case CompProtKind.p_orparallel:
      sb.append("(");
      sb.append(compFrameProtToArch(((CompProtBinOper) p).operand1, names));
      sb.append(")||(");
      sb.append(compFrameProtToArch(((CompProtBinOper) p).operand2, names));
      sb.append(")");
      break;
    case CompProtKind.p_alternative:
      sb.append("(");
      sb.append(compFrameProtToArch(((CompProtBinOper) p).operand1, names));
      sb.append(")+(");
      sb.append(compFrameProtToArch(((CompProtBinOper) p).operand2, names));
      sb.append(")");
      break;
    case CompProtKind.p_sequence:
      sb.append("(");
      sb.append(compFrameProtToArch(((CompProtBinOper) p).operand1, names));
      sb.append(");(");
      sb.append(compFrameProtToArch(((CompProtBinOper) p).operand2, names));
      sb.append(")");
      break;
    case CompProtKind.p_restriction:
      sb.append("(");
      sb.append(compFrameProtToArch(((CompProtBinOper) p).operand1, names));
      sb.append(")/(");
      sb.append(compFrameProtToArch(((CompProtBinOper) p).operand2, names));
      sb.append(")");
      break;
    default: break;
    }
    return sb.toString();
  }

  public static String normFrameProtToArch(ProtocolOperDef p, java.util.ArrayList names) throws RemoteException {
    StringBuffer sb = new StringBuffer();
    int i;
    String ifacename;
    switch (p.get_po_kind().value()) {
    case ProtocolOperKind.pok_operand:
      ProtocolOperandDef op = (ProtocolOperandDef) p;
      if (op.operand_mode().value() == ProtocolMode.pm_in)
        sb.append("?");
      else
        sb.append("!");
      ifacename = op.operand()[0];
      for (i=0;i<names.size();i++) {
        if ( ifacename.compareTo(((reProvReq)(names.get(i))).origName) == 0 ) {
          if (((reProvReq)(names.get(i))).rew != null)
            sb.append(((reProvReq)(names.get(i))).rew);
          else
            sb.append("<"+((reProvReq)(names.get(i))).origName+">");
        }
      }
      sb.append(".");
      sb.append(op.operand()[1]);
      break;
    case ProtocolOperKind.pok_nulloperand:
      sb.append("NULL");
      break;
    case ProtocolOperKind.pok_metaoperand:
      sb.append("[");
      sb.append(((ProtocolMetaOperandDef)p).name());
      sb.append("]");
      break;
    case ProtocolOperKind.pok_nestedoperand:
      ProtocolNestedOperandDef nop = (ProtocolNestedOperandDef) p;
      if (nop.operand_mode().value() == ProtocolMode.pm_in)
        sb.append("?");
      else
        sb.append("!");
      ifacename = nop.operand()[0];
      for (i=0;i<names.size();i++) {
        if ( ifacename.compareTo(((reProvReq)(names.get(i))).origName) == 0 ) {
          if (((reProvReq)(names.get(i))).rew != null)
            sb.append(((reProvReq)(names.get(i))).rew);
          else
            sb.append("<"+((reProvReq)(names.get(i))).origName+">");
        }
      }
      sb.append(".");
      sb.append(nop.operand()[1]);
      sb.append("{");
      sb.append(normFrameProtToArch(nop.nested_operand(), names));
      sb.append("}");
      break;
    case ProtocolOperKind.pok_repetition:
      sb.append("(");
      sb.append(normFrameProtToArch(((ProtocolUnOperationDef) p).operand(), names));
      sb.append(")*");
      break;
    case ProtocolOperKind.pok_andparallel:
      sb.append("(");
      sb.append(normFrameProtToArch(((ProtocolBinOperationDef) p).operand1(), names));
      sb.append(")|(");
      sb.append(normFrameProtToArch(((ProtocolBinOperationDef) p).operand2(), names));
      sb.append(")");
      break;
    case ProtocolOperKind.pok_orparallel:
      sb.append("(");
      sb.append(normFrameProtToArch(((ProtocolBinOperationDef) p).operand1(), names));
      sb.append(")||(");
      sb.append(normFrameProtToArch(((ProtocolBinOperationDef) p).operand2(), names));
      sb.append(")");
      break;
    case ProtocolOperKind.pok_alternative:
      sb.append("(");
      sb.append(normFrameProtToArch(((ProtocolBinOperationDef) p).operand1(), names));
      sb.append(")+(");
      sb.append(normFrameProtToArch(((ProtocolBinOperationDef) p).operand2(), names));
      sb.append(")");
      break;
    case ProtocolOperKind.pok_sequence:
      sb.append("(");
      sb.append(normFrameProtToArch(((ProtocolBinOperationDef) p).operand1(), names));
      sb.append(");(");
      sb.append(normFrameProtToArch(((ProtocolBinOperationDef) p).operand2(), names));
      sb.append(")");
      break;
    case ProtocolOperKind.pok_restriction:
      sb.append("(");
      sb.append(normFrameProtToArch(((ProtocolBinOperationDef) p).operand1(), names));
      sb.append(")/(");
      sb.append(normFrameProtToArch(((ProtocolBinOperationDef) p).operand2(), names));
      sb.append(")");
      break;
    default: break;
    }
    return sb.toString();
  }

  static String[] getNormFrameProvideOperations(ProvideDef provide, CompRepository repository) throws CDLExceptLock, CDLExceptRemote {
    try {
      InterfaceDef iface = (InterfaceDef) provide.provide();
      CompReffer ref = new CompReffer();
      ref.isNew = false;
      ref.what = DefinitionKind.dk_Interface;
      ref.ref = new FullID(true);
      Identification idl;
      ref.ref.name = new String((idl = iface.get_identification()).name());
      ref.ref.version = new String(idl.version());
      ref.ref.isin = IDKind.version;
      AbsoluteName abs = idl.absolute_name();
      for(int j=0;j<abs.size()-1;j++) {
        ref.ref.sn.addScope(new String(abs.elementAt(j)));
      }
      EnumList ret = CompProvide.ifaceOperations(ref,repository);
      if (ret==null)
        return null;
      else
        return ret.toArray();
    } catch (RemoteException e) {
      throw new CDLExceptRemote(e.getMessage());
    }
  }

  static String[] getNormFrameRequireOperations(RequireDef require, CompRepository repository) throws CDLExceptLock, CDLExceptRemote {
    try {
      InterfaceDef iface = (InterfaceDef) require.require();
      CompReffer ref = new CompReffer();
      ref.isNew = false;
      ref.what = DefinitionKind.dk_Interface;
      ref.ref = new FullID(true);
      Identification idl;
      ref.ref.name = new String((idl = iface.get_identification()).name());
      ref.ref.version = new String(idl.version());
      ref.ref.isin = IDKind.version;
      AbsoluteName abs = idl.absolute_name();
      for(int j=0;j<abs.size()-1;j++) {
        ref.ref.sn.addScope(new String(abs.elementAt(j)));
      }
      EnumList ret = CompProvide.ifaceOperations(ref,repository);
      if (ret==null)
        return null;
      else
        return ret.toArray();
    } catch (RemoteException e) {
      throw new CDLExceptRemote(e.getMessage());
    }
  }

  /** Returns frame which is instantiated even if it is array of frames */
  public static CompReffer getInstFrame(CompReffer what, CompRepository inRep) throws CDLExceptLock, CDLExceptRemote {
    boolean ok = false;
    int kind = what.what;
    CompReffer r = what;
    while (!ok) {
      if (kind != ObjectsKind.o_Frame) {
        if (kind == ObjectsKind.o_Typedef || kind == ObjectsKind.o_Array) {
          int i,j;
          FullID id = r.ref;
          if (r.isNew) {  // in actually added objects
            CompContainer con = inRep;
            id.sn.names.toFirst();
            for(i=0;i<id.sn.names.size();i++) {
              CompContained[] a = con.lookup((String) id.sn.names.aktual());
              if (a==null || a.length==0) {
                return null;
              }  
              if (a.length==1) {
                if (a[0].isContainer()) con = (CompContainer) a[0];
                else {
                  return null;
                }  
              } else {
                return null;
              }
              id.sn.names.toNext();
            }
            CompContained sec = con.lookup(id.name, id.version);
            if (sec!=null) {
              CompType sectype = ((CompTypedef) sec).type;
              if (sectype.objectKind() != ObjectsKind.o_Frame) {
                if (sectype.objectKind()==ObjectsKind.o_none) { // is CompReffer
                  r = (CompReffer) sectype;
                  kind = r.what;
                } else {
                  if (sectype.objectKind()==ObjectsKind.o_Array) {
                    while (sectype.objectKind()==ObjectsKind.o_Array) {
                       sectype = ((CompArray) sectype).type;
                    }
                    if (sectype.objectKind() != ObjectsKind.o_none) {
                      if (sectype.objectKind() == ObjectsKind.o_Frame) {
                        r = (CompReffer) sectype;
                        ok = true;
                      } else {
                        return null;
                      }  
                    } else {
                      r = (CompReffer) sectype;
                      kind = r.what;
                    }
                  } else {
                    return null;
                  }
                }  
              } else {
                r = (CompReffer) sectype;               
                ok = true;
              }
            } else {
              return null;
            }  
          } else {  // in normal repository
            try {
              Container con = inRep.cdlRepository;
              id.sn.names.toFirst();
              for(i=0;i<id.sn.names.size();i++) {
                Contained[] a = con.lookup_name((String) id.sn.names.aktual());
                if (a==null || a.length==0) {
                  return null;
                }  
                if (a.length==1) {
                  if (a[0] instanceof Container) con = (Container) a[0];
                  else {
                    return null;
                  }  
                } else {
                  boolean found = false;
                  for(j=0;j<a.length;j++) {
                    if (a[j].get_identification().version().compareTo(id.version)==0) {
                      if ( !(a[j] instanceof Container)) {
                        return null;
                      }  
                      found = true;
                      con = (Container) a[j];
                      break;
                    }
                  }
                  if (!found) {
                    return null;
                  }
                }
                id.sn.names.toNext();
              }
              Contained sec = con.lookup(id.name, id.version);
              if (sec!=null) {
                CDLType sectype = ((TypedefDef) sec).original_type();
                if (sectype.get_def_kind().value() != DefinitionKind.dk_Interface) {
                  if (sectype.get_def_kind().value() == DefinitionKind.dk_Typedef) {
                    CompReffer ret = new CompReffer();
                    ret.what = sectype.get_def_kind().value();
                    ret.ref = new FullID(true);
                    Identification idl;
                    ret.ref.name = new String((idl = ((TypedefDef)sectype).get_identification()).name());
                    ret.ref.version = new String(idl.version());
                    ret.ref.isin = IDKind.version;
                    ret.isNew = false;
                    AbsoluteName abs = idl.absolute_name();
                    for(j=0;j<abs.size();j++) {
                      ret.ref.sn.addScope(new String(abs.elementAt(j)));
                    }
                    r = ret;
                    kind = r.what;
                  } else {
                    if (sectype.get_def_kind().value()==DefinitionKind.dk_Array) {
                      while (sectype.get_def_kind().value()==DefinitionKind.dk_Array) {
                        sectype = ((ArrayDef) sectype).element_type();
                      }
                      if (sectype.get_def_kind().value()!=DefinitionKind.dk_Typedef) {
                        if (sectype.get_def_kind().value()==DefinitionKind.dk_Interface) {
                          CompReffer ret = new CompReffer();
                          ret.what = sectype.get_def_kind().value();
                          ret.ref = new FullID(true);
                          Identification idl;
                          ret.ref.name = new String((idl = ((TypedefDef)sectype).get_identification()).name());
                          ret.ref.version = new String(idl.version());
                          ret.ref.isin = IDKind.version;
                          ret.isNew = false;
                          AbsoluteName abs = idl.absolute_name();
                          for(j=0;j<abs.size();j++) {
                            ret.ref.sn.addScope(new String(abs.elementAt(j)));
                          }
                          r = ret;
                          ok = true;
                        } else { 
                          return null;
                        }
                      } else {
                        CompReffer ret = new CompReffer();
                        ret.what = sectype.get_def_kind().value();
                        ret.ref = new FullID(true);
                        Identification idl;
                        ret.ref.name = new String((idl = ((TypedefDef)sectype).get_identification()).name());
                        ret.ref.version = new String(idl.version());
                        ret.ref.isin = IDKind.version;
                        ret.isNew = false;
                        AbsoluteName abs = idl.absolute_name();
                        for(j=0;j<abs.size();j++) {
                          ret.ref.sn.addScope(new String(abs.elementAt(j)));
                        }
                        r = ret;
                        kind = r.what;   
                      }
                    } else {
                      return null;
                    }
                  }  
                } else {
                  CompReffer ret = new CompReffer();
                  ret.what = sectype.get_def_kind().value();
                  ret.ref = new FullID(true);
                  Identification idl;
                  ret.ref.name = new String((idl = ((TypedefDef)sectype).get_identification()).name());
                  ret.ref.version = new String(idl.version());
                  ret.ref.isin = IDKind.version;
                  ret.isNew = false;
                  AbsoluteName abs = idl.absolute_name();
                  for(j=0;j<abs.size();j++) {
                    ret.ref.sn.addScope(new String(abs.elementAt(j)));
                  }
                  r = ret;
                  ok = true;
                }
              } else {
                return null;
              }
            } catch (TIRExceptLock e) {
              throw new CDLExceptLock("Repository is locked.");
            } catch (RemoteException e) {
              throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
            }
          }
        } else {
          return null;
	}
      } else {
        ok = true;
      }
    }
    return r;
  }
}
