/* $Id: CompOperation.java,v 2.0 2002/02/15 13:54:48 hnetynka Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;

class CompOperation extends CompContainedIm {
  public CompType type;
  public List params;
  public List raises;

  public CompOperation(ID id, CompContainer parent, CompRepository rep, CompType type, List params, List raises) {
    super(ObjectsKind.o_Operation, id, parent, rep);
    id.version = ((CompContained)parent).getIdent().version;
    this.type = type;
    this.params = params;
    this.raises = raises;
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    int i;
    type.checkConsist(props, rep);
    raises.toFirst();
    for (i=0;i<raises.size();i++) {
      ((CompObject) raises.aktual()).checkConsist(props,rep);
      raises.toNext();
    }
    params.toFirst();
    for (i=0;i<params.size();i++) {
      ((CompParam) params.aktual()).type.checkConsist(props,rep);
      params.toNext();
    }
  }

  public void addToNormal(OperationDef obj, CDLRepository normRep) throws CDLExceptToNormal, CDLExceptRemote, CDLExceptLock {
    params.toFirst();
    try {
      for (int i=0;i<params.size(); i++) {
        CompParam pp = (CompParam) params.aktual();
        try {
          ParamDescr par = obj.create_parametr(pp.name, pp.type.toNormal(normRep), pp.mode);
          if (par == null)
            throw new CDLExceptToNormal("Can't create param in operation "+fullName()); 
        } catch (TIRExceptCreate ecr) {
          throw new CDLExceptToNormal("Can't create param in operation "+fullName());
        }
        params.toNext();
      }
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptLock e) {
      throw new CDLExceptLock("Repository is locked.");
    }
  }
}
