/* $Id: CompString.java,v 2.0 2002/02/15 13:54:50 hnetynka Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;

class CompString extends CompObjectIm implements CompType {
  public CompExprOper bound;

  public CompString(CompExprOper e) {
    super(ObjectsKind.o_String);
    bound = e;
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    if (!CompExprOper.testPropInExpr(props, bound.nameProp(rep)))
      throw new CDLExceptCheck("Unknown property");
  }

  public CDLType toNormal(CDLRepository newRep) throws CDLExceptRemote, CDLExceptToNormal, CDLExceptLock {
    try {
      return newRep.create_string(bound.toNormal(newRep));
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptCreate e) {
      throw new CDLExceptToNormal("Can't get primitve type\n"+e.getMessage());
    }
  }
}
