/* $Id: ConsoleLogger.java,v 2.0 2002/02/15 13:54:51 hnetynka Exp $ */
package SOFA.SOFAnode.Made.CDL;

/** Logger class for console.
  *
  * @author Petr Hnetynka
  */
public class ConsoleLogger implements ILogger {
  protected int color;       // current color
  private boolean useColor;  // if setColor was used

  public ConsoleLogger() {
    color = 1;
    useColor = false;
  }

  private void printColor(int c) {
    switch (color) {
      case Black: System.out.println("\033[30m"); break;
      case White: System.out.println("\033[37m"); break;
      case Yellow: System.out.println("\033[33m"); break;
      case Green: System.out.println("\033[32m"); break;
      case Red: System.out.println("\033[31m"); break;
      case Blue: System.out.println("\033[34m"); break;
      case Magenta: System.out.println("\033[35m"); break;
      case Cyan: System.out.println("\033[36m"); break;
    }
  }

  public void print(String s) {
    System.out.print(s);
  }
  public void print(Object o) {
    System.out.print(o);
  }
  public void println(String s) {
    System.out.println(s);
  }
  public void println(Object o) {
    System.out.println(o);
  }
  public void flush() {
    System.out.flush();
  }

  public void setColor(int color) {
    this.color = color;
    useColor = true;
    printColor(color);
  }

  public int getColor() {
    return color;
  }
  
  public boolean supportColors() {
    return true;
  }

  public void reset() {}
  public boolean supportReset() {
    return false;
  }
}
