/* $Id: FullID.java,v 2.1 2002/05/15 14:47:34 hnetynka Exp $ */
package SOFA.SOFAnode.Made.CDL;

class FullID {
  public Scopename sn;
  public String name;
  public String version;
  public String tag;
  public int isin; 
  public boolean isAbsolute;

  public FullID(boolean isAbs) {
    sn = new Scopename();
    name = null;
    version = null;
    tag = null;
    isin = IDKind.none;
    isAbsolute = isAbs;
  }
  
  public FullID(String name, String vt) {
    if (vt == null || vt.length()==0) {
      isin = IDKind.none;
      tag = null;
      version = null;
    } else {  
      if (vt.indexOf('!')==-1) {
        version = null;
        isin = IDKind.tag;
        tag = new String(vt);
      } else {
        version = new String(vt);
        isin = IDKind.version;
        tag = null;
      }
    }
    int i;
    int count = 0;
    
    isAbsolute = true;
    
    for (i=0;i<name.length();i++) {
      if (name.charAt(i)==':' && name.charAt(i+1)==':') 
        count++;
    }
    int j = 0;
    for(i=0;i<count;i++) {
      StringBuffer str = new StringBuffer();
      while (name.charAt(j)==':')
        j++;
      while (name.charAt(j)!=':' && j<name.length()) {
        str = str.append(name.charAt(j));
        j++;
      }
      if (i==count-1)
        this.name = str.toString();
      else 
        sn.addScope(str.toString());
    }   
  }
  
  public FullID(FullID a) {
    isAbsolute = a.isAbsolute;
    name = new String(a.name);
    if (a.version != null)
      version = new String(a.version);
    else
      version = null;
    if (a.tag != null)
      tag = new String(a.tag);
    else
      tag = null;
    isin = a.isin;
    sn = new Scopename();
    a.sn.names.toFirst();
    for(int i=0;i<a.sn.length();i++) {
      sn.addScope(new String((String)a.sn.names.aktual()));
      a.sn.names.toNext();
    }
  }

  public void setVersion(String vt) {
    if (vt == null || vt.length()==0) {
      isin = IDKind.none;
      tag = null;
      version = null;
    } else {  
      if (vt.indexOf('!')==-1) {
        version = null;
        isin = IDKind.tag;
        tag = new String(vt);
      } else {
        version = new String(vt);
        isin = IDKind.version;
        tag = null;
      }
    }
  }

  public String toString() {
    if (sn.length()==0)
      return "::"+name+":"+version;
    else 
      return sn.toString()+"::"+name+":"+version;
  }

  public String toStringWithoutVersion() {
    if (sn.length()==0)
      return "::"+name;
    else 
      return sn.toString()+"::"+name;
  }

  public String langToString() {
    if (sn.length()==0)
      return "::"+ID.lang+"::"+name;
    else 
      return "::"+ID.lang+sn.toString()+"::"+name;
  }
}
