/* $Id: cdl.lex,v 2.1 2002/04/19 12:25:52 hnetynka Exp $ */
package SOFA.SOFAnode.Made.CDL;
import java_cup.runtime.Symbol;
class Convert {
  static char pow(char x, int n) {  /* x**n */
    int i;
    char ret = 1;
    for(i=0;i<n;i++) {
      ret *= x;
    }
    return ret;
  }
  static boolean isHexaDigit(char c) {
    if ((c>='0')&&(c<='9'))
      return true;
    if ((c>='a')&&(c<='f'))
      return true;
    if ((c>='A')&&(c<='F')) 
      return true;
    return false;
  }
  public static boolean isOctalDigit(char c) {
    if ((c>='0')&&(c<='7'))
      return true;
    return false;
  }
  public static Character toCharacter(String str) {
    char ret = 0;
    int i,j=0;
    if (str.charAt(j) == 'L')
      j++;
    j++;  /* move behind ' */  
    if (str.charAt(j)=='\\') {
      switch (str.charAt(j+1)) {
        case '\\': ret = '\\';
                   break;
        case 'n': ret = '\n';
	          break;
	case 'r': ret = '\r';
	          break;
	case 't': ret = '\t';
	          break;
	case 'f': ret = '\f';
	          break;
	case 'b': ret = '\b';
	          break;
	case 'a': ret = 7;    /* alert - no escape sequence in Java */
	          break;
	case 'v': ret = 11;   /* vert. tab - no escape sequence in Java */
	          break;
	case '?': ret = '?';
	          break;
	case '\"': ret = '\"';
		   break;
	case '\'': ret = '\'';
	           break;
	case 'x': i = j+2;
	          while (str.charAt(i) != '\'') {
	            ret *= 16;
	            if (!Character.isDigit(str.charAt(i))) {
		      ret += Character.toLowerCase(str.charAt(i)) - 'a' + 10;
		    } else {
                      ret += str.charAt(i) - '0';
		    }
		    i++;
		  }
		  break;
	case 'u': i = j+2;
	          while (str.charAt(i) != '\'') {
	            ret *= 16;
	            if (!Character.isDigit(str.charAt(i))) {
		      ret += Character.toLowerCase(str.charAt(i)) - 'a' + 10;
		    } else {
                      ret += str.charAt(i) - '0';
		    }
		    i++;
		  }
		  break;
	default : /* octal number */
		  i = j+1;
	          while (str.charAt(i) != '\'') {
	            ret *= 8;
                    ret += str.charAt(i) - '0';
		    i++;
		  }
      }
    } else {
      ret = str.charAt(0);
    }
    return new Character(ret);
  }
  public static String toString(String str) {
    int i,j;
    char c = 0;
    boolean uv = false;
    StringBuffer ret = new StringBuffer();
    i = 0;
    if (str.charAt(i)=='L')
      i++;
    while (i<str.length()) {
      if (!uv) {
        if (str.charAt(i)=='\"') {
	  uv = true;
	}
        i++;
      } else {
        if (str.charAt(i)=='\\') {
          i++;
	  switch (str.charAt(i)) {
          case '\\': ret = ret.append('\\');
                     break;
          case 'n': ret = ret.append('\n');
	            break;
	  case 'r': ret = ret.append('\r');
	            break;
	  case 't': ret = ret.append('\t');
	            break;
	  case 'f': ret = ret.append('\f');
	            break;
	  case 'b': ret = ret.append('\b');
	            break;
	  case 'a': ret = ret.append((char)7);  /* alert - no escape sequence in Java */
	            break;
	  case 'v': ret = ret.append((char)11); /* vert. tab - no escape sequence in Java */
	            break;
	  case '?': ret = ret.append('?');
	            break;
	  case '\"': ret = ret.append('\"');
	      	     break;
	  case '\'': ret = ret.append('\'');
	             break;
	  case 'x' : j = ++i;
	             while (i<str.length() && (i-j<2) && isHexaDigit(str.charAt(i))) {
	               c *= 16;
	               if (!Character.isDigit(str.charAt(i))) {
		         c += Character.toLowerCase(str.charAt(i)) - 'a' + 10;
		       } else {
                         c += str.charAt(i) - '0';
		       }
		       i++;
		     }
		     ret = ret.append(c);
		     i--;
	             break;
	  case 'u' : j = ++i;
	             while (i<str.length() && (i-j<4) && isHexaDigit(str.charAt(i))) {
	               c *= 16;
	               if (!Character.isDigit(str.charAt(i))) {
		         c += Character.toLowerCase(str.charAt(i)) - 'a' + 10;
		       } else {
                         c += str.charAt(i) - '0';
		       }
		       i++;
		     }
		     ret = ret.append(c);
		     i--;
	             break;
          case '0' :
          case '1' :
          case '2' :
          case '3' : j = i;
	             while (i<str.length() && (i-j<3) && isOctalDigit(str.charAt(i))) {
	               c *= 8;
	               c += str.charAt(i) - '0';
		       i++;
		     }
		     ret = ret.append(c);
		     i--;
	             break;
          case '4' :
          case '5' :
          case '6' :
          case '7' : j = i;
	             while (i<str.length() && (i-j<2) && isOctalDigit(str.charAt(i))) {
	               c *= 8;
	               c += str.charAt(i) - '0';
		       i++;
		     }
		     ret = ret.append(c);
		     i--;
	             break;
          }
        } else if (str.charAt(i)=='\"'){
          uv = false;
        } else {
          ret = ret.append(str.charAt(i));
        }
        i++;
      }	
    }
    return ret.toString();
  }
}


class Yylex implements java_cup.runtime.Scanner {
	private final int YY_BUFFER_SIZE = 512;
	private final int YY_F = -1;
	private final int YY_NO_STATE = -1;
	private final int YY_NOT_ACCEPT = 0;
	private final int YY_START = 1;
	private final int YY_END = 2;
	private final int YY_NO_ANCHOR = 4;
	private final int YY_BOL = 128;
	private final int YY_EOF = 129;

public LineInfo lineinfo;
	private java.io.BufferedReader yy_reader;
	private int yy_buffer_index;
	private int yy_buffer_read;
	private int yy_buffer_start;
	private int yy_buffer_end;
	private char yy_buffer[];
	private int yychar;
	private int yyline;
	private boolean yy_at_bol;
	private int yy_lexical_state;

	Yylex (java.io.Reader reader) {
		this ();
		if (null == reader) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(reader);
	}

	Yylex (java.io.InputStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}

	private Yylex () {
		yy_buffer = new char[YY_BUFFER_SIZE];
		yy_buffer_read = 0;
		yy_buffer_index = 0;
		yy_buffer_start = 0;
		yy_buffer_end = 0;
		yychar = 0;
		yyline = 0;
		yy_at_bol = true;
		yy_lexical_state = YYINITIAL;

lineinfo = new LineInfo();
	}

	private boolean yy_eof_done = false;
	private final int YYINITIAL = 0;
	private final int STATE_IN_ARR_EXP = 1;
	private final int yy_state_dtrans[] = {
		0,
		207
	};
	private void yybegin (int state) {
		yy_lexical_state = state;
	}
	private int yy_advance ()
		throws java.io.IOException {
		int next_read;
		int i;
		int j;

		if (yy_buffer_index < yy_buffer_read) {
			return yy_buffer[yy_buffer_index++];
		}

		if (0 != yy_buffer_start) {
			i = yy_buffer_start;
			j = 0;
			while (i < yy_buffer_read) {
				yy_buffer[j] = yy_buffer[i];
				++i;
				++j;
			}
			yy_buffer_end = yy_buffer_end - yy_buffer_start;
			yy_buffer_start = 0;
			yy_buffer_read = j;
			yy_buffer_index = j;
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}

		while (yy_buffer_index >= yy_buffer_read) {
			if (yy_buffer_index >= yy_buffer.length) {
				yy_buffer = yy_double(yy_buffer);
			}
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}
		return yy_buffer[yy_buffer_index++];
	}
	private void yy_move_end () {
		if (yy_buffer_end > yy_buffer_start &&
		    '\n' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
		if (yy_buffer_end > yy_buffer_start &&
		    '\r' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
	}
	private boolean yy_last_was_cr=false;
	private void yy_mark_start () {
		int i;
		for (i = yy_buffer_start; i < yy_buffer_index; ++i) {
			if ('\n' == yy_buffer[i] && !yy_last_was_cr) {
				++yyline;
			}
			if ('\r' == yy_buffer[i]) {
				++yyline;
				yy_last_was_cr=true;
			} else yy_last_was_cr=false;
		}
		yychar = yychar
			+ yy_buffer_index - yy_buffer_start;
		yy_buffer_start = yy_buffer_index;
	}
	private void yy_mark_end () {
		yy_buffer_end = yy_buffer_index;
	}
	private void yy_to_mark () {
		yy_buffer_index = yy_buffer_end;
		yy_at_bol = (yy_buffer_end > yy_buffer_start) &&
		            ('\r' == yy_buffer[yy_buffer_end-1] ||
		             '\n' == yy_buffer[yy_buffer_end-1] ||
		             2028/*LS*/ == yy_buffer[yy_buffer_end-1] ||
		             2029/*PS*/ == yy_buffer[yy_buffer_end-1]);
	}
	private java.lang.String yytext () {
		return (new java.lang.String(yy_buffer,
			yy_buffer_start,
			yy_buffer_end - yy_buffer_start));
	}
	private int yylength () {
		return yy_buffer_end - yy_buffer_start;
	}
	private char[] yy_double (char buf[]) {
		int i;
		char newbuf[];
		newbuf = new char[2*buf.length];
		for (i = 0; i < buf.length; ++i) {
			newbuf[i] = buf[i];
		}
		return newbuf;
	}
	private final int YY_E_INTERNAL = 0;
	private final int YY_E_MATCH = 1;
	private java.lang.String yy_error_string[] = {
		"Error: Internal error.\n",
		"Error: Unmatched input.\n"
	};
	private void yy_error (int code,boolean fatal) {
		java.lang.System.out.print(yy_error_string[code]);
		java.lang.System.out.flush();
		if (fatal) {
			throw new Error("Fatal Error.\n");
		}
	}
	private int[][] unpackFromString(int size1, int size2, String st) {
		int colonIndex = -1;
		String lengthString;
		int sequenceLength = 0;
		int sequenceInteger = 0;

		int commaIndex;
		String workString;

		int res[][] = new int[size1][size2];
		for (int i= 0; i < size1; i++) {
			for (int j= 0; j < size2; j++) {
				if (sequenceLength != 0) {
					res[i][j] = sequenceInteger;
					sequenceLength--;
					continue;
				}
				commaIndex = st.indexOf(',');
				workString = (commaIndex==-1) ? st :
					st.substring(0, commaIndex);
				st = st.substring(commaIndex+1);
				colonIndex = workString.indexOf(':');
				if (colonIndex == -1) {
					res[i][j]=Integer.parseInt(workString);
					continue;
				}
				lengthString =
					workString.substring(colonIndex+1);
				sequenceLength=Integer.parseInt(lengthString);
				workString=workString.substring(0,colonIndex);
				sequenceInteger=Integer.parseInt(workString);
				res[i][j] = sequenceInteger;
				sequenceLength--;
			}
		}
		return res;
	}
	private int yy_acpt[] = {
		/* 0 */ YY_NOT_ACCEPT,
		/* 1 */ YY_NO_ANCHOR,
		/* 2 */ YY_NO_ANCHOR,
		/* 3 */ YY_NO_ANCHOR,
		/* 4 */ YY_NO_ANCHOR,
		/* 5 */ YY_NO_ANCHOR,
		/* 6 */ YY_NO_ANCHOR,
		/* 7 */ YY_NO_ANCHOR,
		/* 8 */ YY_NO_ANCHOR,
		/* 9 */ YY_NO_ANCHOR,
		/* 10 */ YY_NO_ANCHOR,
		/* 11 */ YY_NO_ANCHOR,
		/* 12 */ YY_NO_ANCHOR,
		/* 13 */ YY_NO_ANCHOR,
		/* 14 */ YY_NO_ANCHOR,
		/* 15 */ YY_NO_ANCHOR,
		/* 16 */ YY_NO_ANCHOR,
		/* 17 */ YY_NO_ANCHOR,
		/* 18 */ YY_NO_ANCHOR,
		/* 19 */ YY_NO_ANCHOR,
		/* 20 */ YY_NO_ANCHOR,
		/* 21 */ YY_NO_ANCHOR,
		/* 22 */ YY_NO_ANCHOR,
		/* 23 */ YY_NO_ANCHOR,
		/* 24 */ YY_NO_ANCHOR,
		/* 25 */ YY_NO_ANCHOR,
		/* 26 */ YY_NO_ANCHOR,
		/* 27 */ YY_NO_ANCHOR,
		/* 28 */ YY_NO_ANCHOR,
		/* 29 */ YY_NO_ANCHOR,
		/* 30 */ YY_NO_ANCHOR,
		/* 31 */ YY_NO_ANCHOR,
		/* 32 */ YY_NO_ANCHOR,
		/* 33 */ YY_NO_ANCHOR,
		/* 34 */ YY_NO_ANCHOR,
		/* 35 */ YY_NO_ANCHOR,
		/* 36 */ YY_NO_ANCHOR,
		/* 37 */ YY_NO_ANCHOR,
		/* 38 */ YY_NO_ANCHOR,
		/* 39 */ YY_NO_ANCHOR,
		/* 40 */ YY_END,
		/* 41 */ YY_NO_ANCHOR,
		/* 42 */ YY_NO_ANCHOR,
		/* 43 */ YY_NO_ANCHOR,
		/* 44 */ YY_NO_ANCHOR,
		/* 45 */ YY_NO_ANCHOR,
		/* 46 */ YY_NO_ANCHOR,
		/* 47 */ YY_NO_ANCHOR,
		/* 48 */ YY_NO_ANCHOR,
		/* 49 */ YY_NO_ANCHOR,
		/* 50 */ YY_NO_ANCHOR,
		/* 51 */ YY_NO_ANCHOR,
		/* 52 */ YY_NO_ANCHOR,
		/* 53 */ YY_NO_ANCHOR,
		/* 54 */ YY_NO_ANCHOR,
		/* 55 */ YY_NO_ANCHOR,
		/* 56 */ YY_NO_ANCHOR,
		/* 57 */ YY_NO_ANCHOR,
		/* 58 */ YY_NO_ANCHOR,
		/* 59 */ YY_NO_ANCHOR,
		/* 60 */ YY_NO_ANCHOR,
		/* 61 */ YY_NO_ANCHOR,
		/* 62 */ YY_NO_ANCHOR,
		/* 63 */ YY_NO_ANCHOR,
		/* 64 */ YY_NO_ANCHOR,
		/* 65 */ YY_NO_ANCHOR,
		/* 66 */ YY_NO_ANCHOR,
		/* 67 */ YY_NO_ANCHOR,
		/* 68 */ YY_NO_ANCHOR,
		/* 69 */ YY_NO_ANCHOR,
		/* 70 */ YY_NO_ANCHOR,
		/* 71 */ YY_NO_ANCHOR,
		/* 72 */ YY_NO_ANCHOR,
		/* 73 */ YY_NO_ANCHOR,
		/* 74 */ YY_NO_ANCHOR,
		/* 75 */ YY_NO_ANCHOR,
		/* 76 */ YY_NO_ANCHOR,
		/* 77 */ YY_NO_ANCHOR,
		/* 78 */ YY_NO_ANCHOR,
		/* 79 */ YY_NO_ANCHOR,
		/* 80 */ YY_NO_ANCHOR,
		/* 81 */ YY_NO_ANCHOR,
		/* 82 */ YY_NO_ANCHOR,
		/* 83 */ YY_NO_ANCHOR,
		/* 84 */ YY_NO_ANCHOR,
		/* 85 */ YY_NO_ANCHOR,
		/* 86 */ YY_NO_ANCHOR,
		/* 87 */ YY_NO_ANCHOR,
		/* 88 */ YY_NO_ANCHOR,
		/* 89 */ YY_NO_ANCHOR,
		/* 90 */ YY_NO_ANCHOR,
		/* 91 */ YY_NO_ANCHOR,
		/* 92 */ YY_NO_ANCHOR,
		/* 93 */ YY_NO_ANCHOR,
		/* 94 */ YY_NO_ANCHOR,
		/* 95 */ YY_NO_ANCHOR,
		/* 96 */ YY_NO_ANCHOR,
		/* 97 */ YY_NO_ANCHOR,
		/* 98 */ YY_NO_ANCHOR,
		/* 99 */ YY_NO_ANCHOR,
		/* 100 */ YY_NO_ANCHOR,
		/* 101 */ YY_NO_ANCHOR,
		/* 102 */ YY_NO_ANCHOR,
		/* 103 */ YY_NO_ANCHOR,
		/* 104 */ YY_NOT_ACCEPT,
		/* 105 */ YY_NO_ANCHOR,
		/* 106 */ YY_NO_ANCHOR,
		/* 107 */ YY_NO_ANCHOR,
		/* 108 */ YY_NO_ANCHOR,
		/* 109 */ YY_NO_ANCHOR,
		/* 110 */ YY_END,
		/* 111 */ YY_NO_ANCHOR,
		/* 112 */ YY_NO_ANCHOR,
		/* 113 */ YY_NOT_ACCEPT,
		/* 114 */ YY_NO_ANCHOR,
		/* 115 */ YY_NO_ANCHOR,
		/* 116 */ YY_NO_ANCHOR,
		/* 117 */ YY_NOT_ACCEPT,
		/* 118 */ YY_NO_ANCHOR,
		/* 119 */ YY_NO_ANCHOR,
		/* 120 */ YY_NOT_ACCEPT,
		/* 121 */ YY_NO_ANCHOR,
		/* 122 */ YY_NO_ANCHOR,
		/* 123 */ YY_NOT_ACCEPT,
		/* 124 */ YY_NO_ANCHOR,
		/* 125 */ YY_NOT_ACCEPT,
		/* 126 */ YY_NO_ANCHOR,
		/* 127 */ YY_NOT_ACCEPT,
		/* 128 */ YY_NO_ANCHOR,
		/* 129 */ YY_NOT_ACCEPT,
		/* 130 */ YY_NO_ANCHOR,
		/* 131 */ YY_NOT_ACCEPT,
		/* 132 */ YY_NO_ANCHOR,
		/* 133 */ YY_NOT_ACCEPT,
		/* 134 */ YY_NO_ANCHOR,
		/* 135 */ YY_NOT_ACCEPT,
		/* 136 */ YY_NO_ANCHOR,
		/* 137 */ YY_NOT_ACCEPT,
		/* 138 */ YY_NO_ANCHOR,
		/* 139 */ YY_NOT_ACCEPT,
		/* 140 */ YY_NO_ANCHOR,
		/* 141 */ YY_NOT_ACCEPT,
		/* 142 */ YY_NO_ANCHOR,
		/* 143 */ YY_NOT_ACCEPT,
		/* 144 */ YY_NO_ANCHOR,
		/* 145 */ YY_NOT_ACCEPT,
		/* 146 */ YY_NO_ANCHOR,
		/* 147 */ YY_NOT_ACCEPT,
		/* 148 */ YY_NO_ANCHOR,
		/* 149 */ YY_NOT_ACCEPT,
		/* 150 */ YY_NO_ANCHOR,
		/* 151 */ YY_NOT_ACCEPT,
		/* 152 */ YY_NO_ANCHOR,
		/* 153 */ YY_NOT_ACCEPT,
		/* 154 */ YY_NO_ANCHOR,
		/* 155 */ YY_NOT_ACCEPT,
		/* 156 */ YY_NO_ANCHOR,
		/* 157 */ YY_NOT_ACCEPT,
		/* 158 */ YY_NO_ANCHOR,
		/* 159 */ YY_NOT_ACCEPT,
		/* 160 */ YY_NO_ANCHOR,
		/* 161 */ YY_NOT_ACCEPT,
		/* 162 */ YY_NO_ANCHOR,
		/* 163 */ YY_NOT_ACCEPT,
		/* 164 */ YY_NO_ANCHOR,
		/* 165 */ YY_NOT_ACCEPT,
		/* 166 */ YY_NO_ANCHOR,
		/* 167 */ YY_NOT_ACCEPT,
		/* 168 */ YY_NO_ANCHOR,
		/* 169 */ YY_NOT_ACCEPT,
		/* 170 */ YY_NO_ANCHOR,
		/* 171 */ YY_NOT_ACCEPT,
		/* 172 */ YY_NO_ANCHOR,
		/* 173 */ YY_NOT_ACCEPT,
		/* 174 */ YY_NO_ANCHOR,
		/* 175 */ YY_NOT_ACCEPT,
		/* 176 */ YY_NO_ANCHOR,
		/* 177 */ YY_NOT_ACCEPT,
		/* 178 */ YY_NO_ANCHOR,
		/* 179 */ YY_NOT_ACCEPT,
		/* 180 */ YY_NO_ANCHOR,
		/* 181 */ YY_NOT_ACCEPT,
		/* 182 */ YY_NO_ANCHOR,
		/* 183 */ YY_NOT_ACCEPT,
		/* 184 */ YY_NO_ANCHOR,
		/* 185 */ YY_NOT_ACCEPT,
		/* 186 */ YY_NO_ANCHOR,
		/* 187 */ YY_NOT_ACCEPT,
		/* 188 */ YY_NO_ANCHOR,
		/* 189 */ YY_NOT_ACCEPT,
		/* 190 */ YY_NO_ANCHOR,
		/* 191 */ YY_NO_ANCHOR,
		/* 192 */ YY_NO_ANCHOR,
		/* 193 */ YY_NO_ANCHOR,
		/* 194 */ YY_NO_ANCHOR,
		/* 195 */ YY_NO_ANCHOR,
		/* 196 */ YY_NO_ANCHOR,
		/* 197 */ YY_NO_ANCHOR,
		/* 198 */ YY_NO_ANCHOR,
		/* 199 */ YY_NO_ANCHOR,
		/* 200 */ YY_NO_ANCHOR,
		/* 201 */ YY_NO_ANCHOR,
		/* 202 */ YY_NO_ANCHOR,
		/* 203 */ YY_NO_ANCHOR,
		/* 204 */ YY_NO_ANCHOR,
		/* 205 */ YY_NO_ANCHOR,
		/* 206 */ YY_NO_ANCHOR,
		/* 207 */ YY_NOT_ACCEPT,
		/* 208 */ YY_NO_ANCHOR,
		/* 209 */ YY_NOT_ACCEPT,
		/* 210 */ YY_NOT_ACCEPT,
		/* 211 */ YY_NOT_ACCEPT,
		/* 212 */ YY_NOT_ACCEPT,
		/* 213 */ YY_NO_ANCHOR,
		/* 214 */ YY_NOT_ACCEPT,
		/* 215 */ YY_NO_ANCHOR,
		/* 216 */ YY_NO_ANCHOR,
		/* 217 */ YY_NO_ANCHOR,
		/* 218 */ YY_NO_ANCHOR,
		/* 219 */ YY_NO_ANCHOR,
		/* 220 */ YY_NO_ANCHOR,
		/* 221 */ YY_NO_ANCHOR,
		/* 222 */ YY_NO_ANCHOR,
		/* 223 */ YY_NO_ANCHOR,
		/* 224 */ YY_NO_ANCHOR,
		/* 225 */ YY_NO_ANCHOR,
		/* 226 */ YY_NO_ANCHOR,
		/* 227 */ YY_NO_ANCHOR,
		/* 228 */ YY_NO_ANCHOR,
		/* 229 */ YY_NO_ANCHOR,
		/* 230 */ YY_NO_ANCHOR,
		/* 231 */ YY_NO_ANCHOR,
		/* 232 */ YY_NO_ANCHOR,
		/* 233 */ YY_NO_ANCHOR,
		/* 234 */ YY_NO_ANCHOR,
		/* 235 */ YY_NO_ANCHOR,
		/* 236 */ YY_NO_ANCHOR,
		/* 237 */ YY_NO_ANCHOR,
		/* 238 */ YY_NO_ANCHOR,
		/* 239 */ YY_NO_ANCHOR,
		/* 240 */ YY_NO_ANCHOR,
		/* 241 */ YY_NO_ANCHOR,
		/* 242 */ YY_NO_ANCHOR,
		/* 243 */ YY_NO_ANCHOR,
		/* 244 */ YY_NO_ANCHOR,
		/* 245 */ YY_NO_ANCHOR,
		/* 246 */ YY_NO_ANCHOR,
		/* 247 */ YY_NO_ANCHOR,
		/* 248 */ YY_NO_ANCHOR,
		/* 249 */ YY_NO_ANCHOR,
		/* 250 */ YY_NO_ANCHOR,
		/* 251 */ YY_NO_ANCHOR,
		/* 252 */ YY_NO_ANCHOR,
		/* 253 */ YY_NO_ANCHOR,
		/* 254 */ YY_NO_ANCHOR,
		/* 255 */ YY_NO_ANCHOR,
		/* 256 */ YY_NO_ANCHOR,
		/* 257 */ YY_NO_ANCHOR,
		/* 258 */ YY_NO_ANCHOR,
		/* 259 */ YY_NO_ANCHOR,
		/* 260 */ YY_NO_ANCHOR,
		/* 261 */ YY_NO_ANCHOR,
		/* 262 */ YY_NO_ANCHOR,
		/* 263 */ YY_NO_ANCHOR,
		/* 264 */ YY_NOT_ACCEPT,
		/* 265 */ YY_NO_ANCHOR,
		/* 266 */ YY_NO_ANCHOR,
		/* 267 */ YY_NO_ANCHOR,
		/* 268 */ YY_NO_ANCHOR,
		/* 269 */ YY_NO_ANCHOR,
		/* 270 */ YY_NO_ANCHOR,
		/* 271 */ YY_NO_ANCHOR,
		/* 272 */ YY_NO_ANCHOR,
		/* 273 */ YY_NO_ANCHOR,
		/* 274 */ YY_NO_ANCHOR,
		/* 275 */ YY_NO_ANCHOR,
		/* 276 */ YY_NO_ANCHOR,
		/* 277 */ YY_NO_ANCHOR,
		/* 278 */ YY_NO_ANCHOR,
		/* 279 */ YY_NO_ANCHOR,
		/* 280 */ YY_NO_ANCHOR,
		/* 281 */ YY_NO_ANCHOR,
		/* 282 */ YY_NO_ANCHOR,
		/* 283 */ YY_NO_ANCHOR,
		/* 284 */ YY_NO_ANCHOR,
		/* 285 */ YY_NO_ANCHOR,
		/* 286 */ YY_NO_ANCHOR,
		/* 287 */ YY_NO_ANCHOR,
		/* 288 */ YY_NO_ANCHOR,
		/* 289 */ YY_NO_ANCHOR,
		/* 290 */ YY_NO_ANCHOR,
		/* 291 */ YY_NO_ANCHOR,
		/* 292 */ YY_NO_ANCHOR,
		/* 293 */ YY_NO_ANCHOR,
		/* 294 */ YY_NO_ANCHOR,
		/* 295 */ YY_NO_ANCHOR,
		/* 296 */ YY_NO_ANCHOR,
		/* 297 */ YY_NO_ANCHOR,
		/* 298 */ YY_NO_ANCHOR,
		/* 299 */ YY_NO_ANCHOR,
		/* 300 */ YY_NO_ANCHOR,
		/* 301 */ YY_NO_ANCHOR,
		/* 302 */ YY_NO_ANCHOR,
		/* 303 */ YY_NO_ANCHOR,
		/* 304 */ YY_NO_ANCHOR,
		/* 305 */ YY_NO_ANCHOR,
		/* 306 */ YY_NO_ANCHOR,
		/* 307 */ YY_NO_ANCHOR,
		/* 308 */ YY_NO_ANCHOR,
		/* 309 */ YY_NO_ANCHOR,
		/* 310 */ YY_NO_ANCHOR,
		/* 311 */ YY_NO_ANCHOR,
		/* 312 */ YY_NO_ANCHOR,
		/* 313 */ YY_NO_ANCHOR,
		/* 314 */ YY_NO_ANCHOR,
		/* 315 */ YY_NO_ANCHOR,
		/* 316 */ YY_NO_ANCHOR,
		/* 317 */ YY_NO_ANCHOR,
		/* 318 */ YY_NO_ANCHOR,
		/* 319 */ YY_NO_ANCHOR,
		/* 320 */ YY_NO_ANCHOR,
		/* 321 */ YY_NO_ANCHOR,
		/* 322 */ YY_NO_ANCHOR,
		/* 323 */ YY_NO_ANCHOR,
		/* 324 */ YY_NO_ANCHOR,
		/* 325 */ YY_NO_ANCHOR,
		/* 326 */ YY_NO_ANCHOR,
		/* 327 */ YY_NO_ANCHOR,
		/* 328 */ YY_NO_ANCHOR,
		/* 329 */ YY_NO_ANCHOR,
		/* 330 */ YY_NO_ANCHOR,
		/* 331 */ YY_NO_ANCHOR,
		/* 332 */ YY_NO_ANCHOR,
		/* 333 */ YY_NO_ANCHOR,
		/* 334 */ YY_NO_ANCHOR,
		/* 335 */ YY_NO_ANCHOR,
		/* 336 */ YY_NO_ANCHOR,
		/* 337 */ YY_NO_ANCHOR,
		/* 338 */ YY_NO_ANCHOR,
		/* 339 */ YY_NO_ANCHOR,
		/* 340 */ YY_NO_ANCHOR,
		/* 341 */ YY_NO_ANCHOR,
		/* 342 */ YY_NO_ANCHOR,
		/* 343 */ YY_NO_ANCHOR,
		/* 344 */ YY_NO_ANCHOR,
		/* 345 */ YY_NO_ANCHOR,
		/* 346 */ YY_NO_ANCHOR,
		/* 347 */ YY_NO_ANCHOR,
		/* 348 */ YY_NO_ANCHOR,
		/* 349 */ YY_NO_ANCHOR,
		/* 350 */ YY_NO_ANCHOR,
		/* 351 */ YY_NO_ANCHOR,
		/* 352 */ YY_NO_ANCHOR,
		/* 353 */ YY_NO_ANCHOR,
		/* 354 */ YY_NO_ANCHOR,
		/* 355 */ YY_NO_ANCHOR,
		/* 356 */ YY_NO_ANCHOR,
		/* 357 */ YY_NO_ANCHOR,
		/* 358 */ YY_NO_ANCHOR,
		/* 359 */ YY_NO_ANCHOR,
		/* 360 */ YY_NO_ANCHOR,
		/* 361 */ YY_NO_ANCHOR,
		/* 362 */ YY_NO_ANCHOR,
		/* 363 */ YY_NO_ANCHOR,
		/* 364 */ YY_NO_ANCHOR,
		/* 365 */ YY_NO_ANCHOR,
		/* 366 */ YY_NO_ANCHOR,
		/* 367 */ YY_NO_ANCHOR,
		/* 368 */ YY_NO_ANCHOR,
		/* 369 */ YY_NO_ANCHOR,
		/* 370 */ YY_NO_ANCHOR,
		/* 371 */ YY_NO_ANCHOR,
		/* 372 */ YY_NO_ANCHOR,
		/* 373 */ YY_NO_ANCHOR,
		/* 374 */ YY_NO_ANCHOR
	};
	private int yy_cmap[] = unpackFromString(1,130,
"4:9,72,5,4,72,3,4:18,72,27,70,4,26,20,22,68,10,11,2,18,9,19,29,1,65,71:7,64" +
":2,8,7,16,25,17,28,4,56,67:2,73,54,55,74:5,57,74,63,59,74:2,52,58,51,53,74:" +
"2,66,74:2,12,69,13,24,74,4,41,49,42,32,35,40,61,47,36,60,74,34,30,37,31,44," +
"48,39,45,38,33,62,46,50,43,74,14,23,15,21,4,0,6")[0];

	private int yy_rmap[] = unpackFromString(1,375,
"0,1,2,1:4,3,1:7,4,5,1:5,6,1:5,7,8,9,1:4,10,11,12,1,13,14,12:3,15,1:2,12:8,1" +
",12:2,1:2,12:11,1:3,12:7,1:2,12:20,1,16,17,18,19,20,21,1,22,23,24,25,26,1,2" +
"7,28,29,30,31,32,33,34,35,36,37,38,39,40,25,41,42,43,44,45,46,47,48,49,50,5" +
"1,52,53,22,54,55,56,57,58,13,59,60,61,62,63,21,64,23,65,66,67,15,68,69,70,7" +
"1,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,9" +
"6,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115," +
"116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134" +
",135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,15" +
"3,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,1" +
"72,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190," +
"191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209" +
",210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,22" +
"8,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,2" +
"47,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265," +
"266,267,268,269,270,271,272,273,12,274,275,276,277")[0];

	private int yy_nxt[][] = unpackFromString(278,75,
"1,2,3,4,5,4,1,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27" +
",28,29,208,362,307,263,265,107,370,115,213,308,215,266,370,373,309,310,370:" +
"2,267,370,268,370:3,311,370,118,370,374,370:2,269,270,30,108,370:2,105,5,11" +
"4,30,4,370:2,-1:76,104,113,-1:80,31,-1:82,32,-1:75,33,-1:80,34,-1:115,35:2," +
"-1:5,35,-1:33,370,312,370:36,-1:3,370,-1,370:2,-1:29,35,-1:2,38,-1:31,30:2," +
"-1:5,30,-1,38,-1:33,38,-1:2,137,-1:18,137,-1:9,35:2,-1:5,35,-1,38,-1:31,370" +
",228,370:6,371,370:6,132,370:22,-1:3,370,-1,370:2,-1:30,370:38,-1:3,370,-1," +
"370:2,-1:3,151,-1,151,-1:64,153,-1,151,-1:7,110,-1:72,163,-1,163,-1:51,165," +
"-1:14,163,-1:3,104:2,40,104,110:2,104:68,-1,127:2,-1,127,-1:2,127:62,129,12" +
"7:5,-1:29,103,-1:34,189:2,-1:5,189,-1:33,316,370:6,36,370:30,-1:3,370,-1,37" +
"0:2,-1:29,35,-1:2,38,-1:17,123,-1:13,30:2,125,-1:4,30,-1,38,-1:65,109:2,-1:" +
"5,109,-1:71,58,-1:74,71,-1:7,113,135,113:3,-1,113:68,-1,131:5,-1,131:62,133" +
",39,131:4,-1:30,370,37,370:11,364,370:24,-1:3,370,-1,370:2,-1,139:2,-1,139," +
"-1:2,139:62,141,139:5,-1:30,370:38,117,-1,120,370,-1,370:2,-1:29,189,-1:2,3" +
"8,-1:31,119:2,-1:5,119,-1,38,-1:2,120:5,-1,120:62,143,44,120:4,-1:30,370:8," +
"41,370:29,-1:3,370,-1,370:2,-1:29,189,-1:2,38,-1:17,123,-1:13,119:2,125,-1:" +
"4,119,-1,38,-1:33,116,-1:2,116,-1:4,116:3,-1:6,116,-1:14,116:2,-1:5,116,-1:" +
"33,370:11,332,370:6,333,370:13,42,370:5,-1:3,370,-1,370:2,-1:54,116:3,-1:7," +
"116:2,-1,116,-1:3,116,-1,116,-1:31,370:13,43,370:24,-1:3,370,-1,370:2,-1:68" +
",45,-1:36,370:31,47,370:6,-1:3,370,-1,370:2,-1:28,145,-1:8,145:5,-1:7,145,1" +
"47,-1:11,145,-1:2,149,-1:2,111,145:2,149,-1:33,48,370:37,-1:3,370,-1,370:2," +
"-1:30,370:8,49,370:29,-1:3,370,-1,370:2,-1:28,131,-1:8,131:5,-1:7,131:2,-1:" +
"11,131,-1:2,131,-1:2,131:4,-1:33,370,50,370:36,-1:3,370,-1,370:2,-1,46,135," +
"155:3,-1,155:68,-1:30,370:5,51,370:32,-1:3,370,-1,370:2,-1:18,157:2,-1:44,1" +
"09:2,-1:5,109,-1:33,370:9,52,370:28,-1:3,370,-1,370:2,-1:68,55,-1:36,370:2," +
"53,370:35,-1:3,370,-1,370:2,-1:28,159,-1:4,209,-1:3,159:5,-1:7,159,214,-1:1" +
"1,159,-1:2,161,-1:2,112,159:2,161,-1:33,370:24,54,370:13,-1:3,370,-1,370:2," +
"-1:28,120,-1:4,120,-1:3,120:5,-1:7,120:2,-1:11,120,-1:2,120,-1:2,120:4,-1:3" +
"3,370:2,56,370:35,-1:3,370,-1,370:2,-1:30,370:27,57,370:10,-1:3,370,-1,370:" +
"2,-1:32,167,-1:2,167,-1:4,167:3,-1:6,167,-1:4,167:3,-1:7,167:2,-1,167,-1:3," +
"167,-1,167,-1:31,370:8,60,370:29,-1:3,370,-1,370:2,-1:65,210,-1:2,59,-1:2,2" +
"10,-1:33,370:7,61,370:30,-1:3,370,-1,370:2,-1:30,370:31,62,370:6,-1:3,370,-" +
"1,370:2,-1,153:5,-1,153:62,169,39,153:4,-1:30,370:8,63,370:29,-1:3,370,-1,3" +
"70:2,-1:2,135,155:3,-1,155:68,-1:30,370:8,64,370:29,-1:3,370,-1,370:2,-1:30" +
",370:2,65,370:35,-1:3,370,-1,370:2,-1:30,370:5,66,370:32,-1:3,370,-1,370:2," +
"-1:65,211,-1:2,72,-1:2,211,-1:33,370:8,67,370:29,-1:3,370,-1,370:2,-1:30,37" +
"0:8,68,370:29,-1:3,370,-1,370:2,-1:70,175,-1:34,370:9,69,370:28,-1:3,370,-1" +
",370:2,-1:32,177,-1:2,177,-1:4,177:3,-1:6,177,-1:4,177:3,-1:7,177:2,-1,177," +
"73,-1:2,177,-1,177,-1:31,370:24,70,370:13,-1:3,370,-1,370:2,-1:28,153,-1:8," +
"153:5,-1:7,153:2,-1:11,153,-1:2,153,-1:2,153:4,-1:33,370:5,74,370:32,-1:3,3" +
"70,-1,370:2,-1:32,264,-1:2,264,-1:4,264:3,-1:6,264,-1:4,264:3,-1:7,264:2,-1" +
",264,81,-1:2,264,-1,264,-1:31,370:5,75,370:32,-1:3,370,-1,370:2,-1:32,181,-" +
"1:2,181,-1:4,181:3,-1:6,181,-1:4,181:3,-1:7,181:2,-1,181,82,-1:2,181,-1,181" +
",-1:31,370:15,76,370:22,-1:3,370,-1,370:2,-1,175:5,-1,175:62,185,44,175:4,-" +
"1:30,370:8,77,370:29,-1:3,370,-1,370:2,-1:68,73,-1:36,370:31,78,370:6,-1:3," +
"370,-1,370:2,-1:68,59,-1:36,79,370:37,-1:3,370,-1,370:2,-1:68,82,-1:36,370:" +
"17,80,370:20,-1:3,370,-1,370:2,-1:68,72,-1:36,370:8,83,370:29,-1:3,370,-1,3" +
"70:2,-1:28,175,-1:4,175,-1:3,175:5,-1:7,175:2,-1:11,175,-1:2,175,-1:2,175:4" +
",-1:33,370:8,84,370:29,-1:3,370,-1,370:2,-1:68,81,-1:36,370:10,85,370:27,-1" +
":3,370,-1,370:2,-1:32,38,-1:31,189:2,-1:5,189,-1,38,-1:31,370:5,86,370:32,-" +
"1:3,370,-1,370:2,-1:30,370:31,87,370:6,-1:3,370,-1,370:2,-1:30,370:7,88,370" +
":30,-1:3,370,-1,370:2,-1:30,370:5,89,370:32,-1:3,370,-1,370:2,-1:30,370:2,9" +
"0,370:35,-1:3,370,-1,370:2,-1:30,370:13,91,370:24,-1:3,370,-1,370:2,-1:30,3" +
"70:15,92,370:22,-1:3,370,-1,370:2,-1:30,370:4,93,370:33,-1:3,370,-1,370:2,-" +
"1:30,370:13,94,370:24,-1:3,370,-1,370:2,-1:30,370:15,95,370:22,-1:3,370,-1," +
"370:2,-1:30,370:5,96,370:32,-1:3,370,-1,370:2,-1:30,370:7,97,370:30,-1:3,37" +
"0,-1,370:2,-1:30,370:5,98,370:32,-1:3,370,-1,370:2,-1:30,370:5,99,370:32,-1" +
":3,370,-1,370:2,-1:30,370:5,100,370:32,-1:3,370,-1,370:2,-1:30,370:15,101,3" +
"70:22,-1:3,370,-1,370:2,-1:30,370:5,102,370:32,-1:3,370,-1,370:2,1,2,3,4,5," +
"4,1,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,106,29,20" +
"8,362,307,263,265,107,370,115,213,308,215,266,370,373,309,310,370:2,267,370" +
",268,370:3,311,370,118,370,374,370:2,269,270,119,122,370:2,105,5,114,119,4," +
"370:2,-1:30,370:3,121,370:8,271,370:25,-1:3,370,-1,370:2,-1:32,171,-1:2,171" +
",-1:4,171:3,-1:6,171,-1:4,171:3,-1:7,171:2,-1,171,-1:3,171,-1,171,-1:66,179" +
",-1:2,59,-1:2,179,-1:68,183,-1:2,72,-1:2,183,-1:35,187,-1:2,187,-1:4,187:3," +
"-1:6,187,-1:4,187:3,-1:7,187:2,-1,187,81,-1:2,187,-1,187,-1:31,370:5,124,37" +
"0:5,317,370:26,-1:3,370,-1,370:2,-1:32,173,-1:2,173,-1:4,173:3,-1:6,173,-1:" +
"4,173:3,-1:7,173:2,-1,173,-1:3,173,-1,173,-1:31,370:3,218,370:3,126,318,363" +
",370:28,-1:3,370,-1,370:2,-1:30,370:7,128,370:30,-1:3,370,-1,370:2,-1:30,37" +
"0:3,130,370:34,-1:3,370,-1,370:2,-1:30,370:8,134,370:29,-1:3,370,-1,370:2,-" +
"1:30,370:15,136,370:22,-1:3,370,-1,370:2,-1:30,370:11,138,370:26,-1:3,370,-" +
"1,370:2,-1:30,370:7,140,370:30,-1:3,370,-1,370:2,-1:30,370:23,142,370:14,-1" +
":3,370,-1,370:2,-1:30,370:6,144,370:31,-1:3,370,-1,370:2,-1:30,370:27,146,3" +
"70:10,-1:3,370,-1,370:2,-1:30,370:5,148,370:32,-1:3,370,-1,370:2,-1:30,370," +
"150,370:36,-1:3,370,-1,370:2,-1:30,370:7,152,370:30,-1:3,370,-1,370:2,-1:30" +
",370:3,154,370:34,-1:3,370,-1,370:2,-1:30,370:11,156,370:26,-1:3,370,-1,370" +
":2,-1:30,370:5,158,370:32,-1:3,370,-1,370:2,-1:30,160,370:37,-1:3,370,-1,37" +
"0:2,-1:30,370:15,162,370:22,-1:3,370,-1,370:2,-1:30,370:9,164,370:28,-1:3,3" +
"70,-1,370:2,-1:30,370:11,166,370:26,-1:3,370,-1,370:2,-1:30,370:28,168,370:" +
"9,-1:3,370,-1,370:2,-1:30,370:4,170,370:33,-1:3,370,-1,370:2,-1:30,370:4,17" +
"2,370:33,-1:3,370,-1,370:2,-1:30,370:5,174,370:32,-1:3,370,-1,370:2,-1:30,3" +
"70:12,176,370:25,-1:3,370,-1,370:2,-1:30,370:7,178,370:30,-1:3,370,-1,370:2" +
",-1:30,370:5,180,370:32,-1:3,370,-1,370:2,-1:30,370:12,182,370:25,-1:3,370," +
"-1,370:2,-1:30,370:12,184,370:25,-1:3,370,-1,370:2,-1:30,370:4,186,370:33,-" +
"1:3,370,-1,370:2,-1:30,370:5,188,370:32,-1:3,370,-1,370:2,-1:30,190,370:37," +
"-1:3,370,-1,370:2,-1:30,370:7,191,370:30,-1:3,370,-1,370:2,-1:30,370:11,192" +
",370:26,-1:3,370,-1,370:2,-1:30,370:8,193,370:29,-1:3,370,-1,370:2,-1:30,37" +
"0:5,194,370:32,-1:3,370,-1,370:2,-1:30,370:4,195,370:33,-1:3,370,-1,370:2,-" +
"1:30,370:5,196,370:32,-1:3,370,-1,370:2,-1:30,370,197,370:36,-1:3,370,-1,37" +
"0:2,-1:30,370:8,198,370:29,-1:3,370,-1,370:2,-1:30,370:5,199,370:32,-1:3,37" +
"0,-1,370:2,-1:30,370:12,200,370:25,-1:3,370,-1,370:2,-1:30,370,201,370:36,-" +
"1:3,370,-1,370:2,-1:30,370:12,202,370:25,-1:3,370,-1,370:2,-1:30,370:8,203," +
"370:29,-1:3,370,-1,370:2,-1:30,370:32,204,370:5,-1:3,370,-1,370:2,-1:30,370" +
":8,205,370:29,-1:3,370,-1,370:2,-1:30,370:9,206,370:28,-1:3,370,-1,370:2,-1" +
":30,370,216,370:36,-1:3,370,-1,370:2,-1:32,212,-1:2,212,-1:4,212:3,-1:6,212" +
",-1:4,212:3,-1:7,212:2,-1,212,81,-1:2,212,-1,212,-1:31,370:7,217,370:12,315" +
",370:17,-1:3,370,-1,370:2,-1:30,370,277,370:9,219,370:5,220,370:20,-1:3,370" +
",-1,370:2,-1:30,370,325,370:4,221,370:31,-1:3,370,-1,370:2,-1:30,370:22,222" +
",370:15,-1:3,370,-1,370:2,-1:30,370,223,370:36,-1:3,370,-1,370:2,-1:30,370:" +
"23,224,370:14,-1:3,370,-1,370:2,-1:30,370:8,225,370:29,-1:3,370,-1,370:2,-1" +
":30,370:6,226,370:8,329,370:22,-1:3,370,-1,370:2,-1:30,370:6,227,370:31,-1:" +
"3,370,-1,370:2,-1:30,370,229,370:36,-1:3,370,-1,370:2,-1:30,370:20,230,370:" +
"17,-1:3,370,-1,370:2,-1:30,370:11,231,370:26,-1:3,370,-1,370:2,-1:30,370:7," +
"232,370:30,-1:3,370,-1,370:2,-1:30,370,233,370:36,-1:3,370,-1,370:2,-1:30,3" +
"70:17,234,370:20,-1:3,370,-1,370:2,-1:30,370:27,235,370:10,-1:3,370,-1,370:" +
"2,-1:30,370:3,236,370:34,-1:3,370,-1,370:2,-1:30,370:19,237,370:18,-1:3,370" +
",-1,370:2,-1:30,370:15,238,370:22,-1:3,370,-1,370:2,-1:30,370:3,239,370:2,2" +
"40,370:31,-1:3,370,-1,370:2,-1:30,370:8,241,370:29,-1:3,370,-1,370:2,-1:30," +
"370:8,242,370:29,-1:3,370,-1,370:2,-1:30,370:5,243,370:32,-1:3,370,-1,370:2" +
",-1:30,370:3,244,370:34,-1:3,370,-1,370:2,-1:30,370:2,245,370:35,-1:3,370,-" +
"1,370:2,-1:30,370:3,246,370:34,-1:3,370,-1,370:2,-1:30,370:6,247,370:31,-1:" +
"3,370,-1,370:2,-1:30,370:5,248,370:32,-1:3,370,-1,370:2,-1:30,370:11,249,37" +
"0:26,-1:3,370,-1,370:2,-1:30,370:7,250,370:30,-1:3,370,-1,370:2,-1:30,370:7" +
",251,370:30,-1:3,370,-1,370:2,-1:30,370:9,252,370:28,-1:3,370,-1,370:2,-1:3" +
"0,370:12,253,370:25,-1:3,370,-1,370:2,-1:30,370:9,254,370:28,-1:3,370,-1,37" +
"0:2,-1:30,370:2,255,370:35,-1:3,370,-1,370:2,-1:30,370:7,256,370:30,-1:3,37" +
"0,-1,370:2,-1:30,370:6,257,370:31,-1:3,370,-1,370:2,-1:30,370:11,258,370:26" +
",-1:3,370,-1,370:2,-1:30,370:3,259,370:34,-1:3,370,-1,370:2,-1:30,370:6,260" +
",370:31,-1:3,370,-1,370:2,-1:30,370:7,261,370:30,-1:3,370,-1,370:2,-1:30,37" +
"0:3,262,370:34,-1:3,370,-1,370:2,-1:30,370:7,272,370:7,273,370:22,-1:3,370," +
"-1,370:2,-1:30,370:4,274,370,275,370:2,276,370:28,-1:3,370,-1,370:2,-1:30,3" +
"70:3,320,370,321,370:2,322,370:4,323,370:2,324,278,370:20,-1:3,370,-1,370:2" +
",-1:30,370:12,279,370:2,365,370:22,-1:3,370,-1,370:2,-1:30,370:26,280,370:1" +
"1,-1:3,370,-1,370:2,-1:30,370:2,281,370:35,-1:3,370,-1,370:2,-1:30,370:3,28" +
"2,370:34,-1:3,370,-1,370:2,-1:30,370:4,327,370:5,328,370:27,-1:3,370,-1,370" +
":2,-1:30,370:12,366,370:25,-1:3,370,-1,370:2,-1:30,370:14,330,370:23,-1:3,3" +
"70,-1,370:2,-1:30,370:6,283,370:31,-1:3,370,-1,370:2,-1:30,370:8,334,370:29" +
",-1:3,370,-1,370:2,-1:30,370,336,370:4,337,370:31,-1:3,370,-1,370:2,-1:30,3" +
"70:19,338,370:18,-1:3,370,-1,370:2,-1:30,370:18,367,370:19,-1:3,370,-1,370:" +
"2,-1:30,370:9,284,370:28,-1:3,370,-1,370:2,-1:30,370:15,285,370:22,-1:3,370" +
",-1,370:2,-1:30,370:6,286,370:31,-1:3,370,-1,370:2,-1:30,370,340,370:36,-1:" +
"3,370,-1,370:2,-1:30,370:30,287,370:7,-1:3,370,-1,370:2,-1:30,370:5,341,370" +
":32,-1:3,370,-1,370:2,-1:30,370:11,288,370:26,-1:3,370,-1,370:2,-1:30,370:6" +
",342,370:31,-1:3,370,-1,370:2,-1:30,370:4,344,370:33,-1:3,370,-1,370:2,-1:3" +
"0,370:5,289,370:32,-1:3,370,-1,370:2,-1:30,370:2,345,370:35,-1:3,370,-1,370" +
":2,-1:30,370:3,346,370:34,-1:3,370,-1,370:2,-1:30,370:9,347,370:28,-1:3,370" +
",-1,370:2,-1:30,370:17,369,370:20,-1:3,370,-1,370:2,-1:30,370:8,348,370:5,3" +
"49,370:17,350,370:5,-1:3,370,-1,370:2,-1:30,372,370:37,-1:3,370,-1,370:2,-1" +
":30,370:15,290,370:22,-1:3,370,-1,370:2,-1:30,370:9,291,370:28,-1:3,370,-1," +
"370:2,-1:30,370:4,292,370:33,-1:3,370,-1,370:2,-1:30,370:31,293,370:6,-1:3," +
"370,-1,370:2,-1:30,370:31,294,370:6,-1:3,370,-1,370:2,-1:30,370:14,352,370:" +
"23,-1:3,370,-1,370:2,-1:30,370:5,353,370:32,-1:3,370,-1,370:2,-1:30,370,295" +
",370:36,-1:3,370,-1,370:2,-1:30,370:6,296,370:31,-1:3,370,-1,370:2,-1:30,37" +
"0:6,355,370:31,-1:3,370,-1,370:2,-1:30,370,297,370:36,-1:3,370,-1,370:2,-1:" +
"30,370:5,298,370:32,-1:3,370,-1,370:2,-1:30,370:6,299,370:31,-1:3,370,-1,37" +
"0:2,-1:30,370:5,300,370:32,-1:3,370,-1,370:2,-1:30,370:8,301,370:29,-1:3,37" +
"0,-1,370:2,-1:30,358,370:37,-1:3,370,-1,370:2,-1:30,370:10,302,370:27,-1:3," +
"370,-1,370:2,-1:30,370:19,303,370:18,-1:3,370,-1,370:2,-1:30,370:8,359,370:" +
"29,-1:3,370,-1,370:2,-1:30,370:8,304,370:29,-1:3,370,-1,370:2,-1:30,370:5,3" +
"05,370:32,-1:3,370,-1,370:2,-1:30,370:5,360,370:32,-1:3,370,-1,370:2,-1:30," +
"370:12,361,370:25,-1:3,370,-1,370:2,-1:30,370:8,306,370:29,-1:3,370,-1,370:" +
"2,-1:30,370,313,370:3,314,370:32,-1:3,370,-1,370:2,-1:30,370:12,335,370:25," +
"-1:3,370,-1,370:2,-1:30,370:14,331,370:23,-1:3,370,-1,370:2,-1:30,370:8,339" +
",370:29,-1:3,370,-1,370:2,-1:30,370:5,343,370:32,-1:3,370,-1,370:2,-1:30,37" +
"0:3,351,370:34,-1:3,370,-1,370:2,-1:30,370:9,354,370:28,-1:3,370,-1,370:2,-" +
"1:30,370:6,356,370:31,-1:3,370,-1,370:2,-1:30,370:5,368,370:32,-1:3,370,-1," +
"370:2,-1:30,370:6,357,370:31,-1:3,370,-1,370:2,-1:30,370:9,319,370:28,-1:3," +
"370,-1,370:2,-1:30,370:19,326,370:18,-1:3,370,-1,370:2");

	public java_cup.runtime.Symbol next_token ()
		throws java.io.IOException {
		int yy_lookahead;
		int yy_anchor = YY_NO_ANCHOR;
		int yy_state = yy_state_dtrans[yy_lexical_state];
		int yy_next_state = YY_NO_STATE;
		int yy_last_accept_state = YY_NO_STATE;
		boolean yy_initial = true;
		int yy_this_accept;

		yy_mark_start();
		yy_this_accept = yy_acpt[yy_state];
		if (YY_NOT_ACCEPT != yy_this_accept) {
			yy_last_accept_state = yy_state;
			yy_mark_end();
		}
		while (true) {
			if (yy_initial && yy_at_bol) yy_lookahead = YY_BOL;
			else yy_lookahead = yy_advance();
			yy_next_state = YY_F;
			yy_next_state = yy_nxt[yy_rmap[yy_state]][yy_cmap[yy_lookahead]];
			if (YY_EOF == yy_lookahead && true == yy_initial) {
				return null;
			}
			if (YY_F != yy_next_state) {
				yy_state = yy_next_state;
				yy_initial = false;
				yy_this_accept = yy_acpt[yy_state];
				if (YY_NOT_ACCEPT != yy_this_accept) {
					yy_last_accept_state = yy_state;
					yy_mark_end();
				}
			}
			else {
				if (YY_NO_STATE == yy_last_accept_state) {
					throw (new Error("Lexical Error: Unmatched Input."));
				}
				else {
					yy_anchor = yy_acpt[yy_last_accept_state];
					if (0 != (YY_END & yy_anchor)) {
						yy_move_end();
					}
					yy_to_mark();
					switch (yy_last_accept_state) {
					case 1:
						
					case -2:
						break;
					case 2:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.DIV,yychar,yychar+yytext().length()); }
					case -3:
						break;
					case 3:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.MUL,yychar,yychar+yytext().length()); }
					case -4:
						break;
					case 4:
						{ /* ignore white spaces */ }
					case -5:
						break;
					case 5:
						{ /* !!! co kdyz nic nepasuje */ System.out.println("NIC"); }
					case -6:
						break;
					case 6:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.SEMICOLON,yychar,yychar+yytext().length()); }
					case -7:
						break;
					case 7:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.COLON,yychar,yychar+yytext().length()); }
					case -8:
						break;
					case 8:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.COMMA,yychar,yychar+yytext().length()); }
					case -9:
						break;
					case 9:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.LPAREN,yychar,yychar+yytext().length()); }
					case -10:
						break;
					case 10:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.RPAREN,yychar,yychar+yytext().length()); }
					case -11:
						break;
					case 11:
						{ lineinfo.add(yyline,yychar); yybegin(STATE_IN_ARR_EXP); return new Symbol(sym.LBRACKET,yychar,yychar+yytext().length()); }
					case -12:
						break;
					case 12:
						{ lineinfo.add(yyline,yychar); yybegin(YYINITIAL); return new Symbol(sym.RBRACKET,yychar,yychar+yytext().length()); }
					case -13:
						break;
					case 13:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.LBRACE,yychar,yychar+yytext().length()); }
					case -14:
						break;
					case 14:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.RBRACE,yychar,yychar+yytext().length()); }
					case -15:
						break;
					case 15:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.LESSTHAN,yychar,yychar+yytext().length()); }
					case -16:
						break;
					case 16:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.GREATERTHAN,yychar,yychar+yytext().length()); }
					case -17:
						break;
					case 17:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.PLUS,yychar,yychar+yytext().length()); }
					case -18:
						break;
					case 18:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.MINUS,yychar,yychar+yytext().length()); }
					case -19:
						break;
					case 19:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.MOD,yychar,yychar+yytext().length()); }
					case -20:
						break;
					case 20:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.TILDE,yychar,yychar+yytext().length()); }
					case -21:
						break;
					case 21:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.AND,yychar,yychar+yytext().length()); }
					case -22:
						break;
					case 22:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.OR,yychar,yychar+yytext().length()); }
					case -23:
						break;
					case 23:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.XOR,yychar,yychar+yytext().length()); }
					case -24:
						break;
					case 24:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.EQUAL,yychar,yychar+yytext().length()); }
					case -25:
						break;
					case 25:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.DOLLAR,yychar,yychar+yytext().length()); }
					case -26:
						break;
					case 26:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.EXCLAM,yychar,yychar+yytext().length()); }
					case -27:
						break;
					case 27:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.QUESTION,yychar,yychar+yytext().length()); }
					case -28:
						break;
					case 28:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.DOT,yychar,yychar+yytext().length()); }
					case -29:
						break;
					case 29:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -30:
						break;
					case 30:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.INTEGER_LITERAL,yychar,yychar+yytext().length(), new Long(yytext())); }
					case -31:
						break;
					case 31:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.DOUBLE_COLON,yychar,yychar+yytext().length()); }
					case -32:
						break;
					case 32:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.SHIFT_LEFT,yychar,yychar+yytext().length()); }
					case -33:
						break;
					case 33:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.SHIFT_RIGHT,yychar,yychar+yytext().length()); }
					case -34:
						break;
					case 34:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.OROR,yychar,yychar+yytext().length()); }
					case -35:
						break;
					case 35:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.FLOATING_PT_LITERAL,yychar,yychar+yytext().length(), new Double(yytext())); }
					case -36:
						break;
					case 36:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IN,yychar,yychar+yytext().length()); }
					case -37:
						break;
					case 37:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.TO,yychar,yychar+yytext().length()); }
					case -38:
						break;
					case 38:
						{return new Symbol(sym.FIXED_PT_LITERAL,yychar,yychar+yytext().length(), new Fixed(yytext())); }
					case -39:
						break;
					case 39:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.STRING_LITERAL,yychar,yychar+yytext().length(), Convert.toString(yytext())); }
					case -40:
						break;
					case 40:
						{ /* comments */ }
					case -41:
						break;
					case 41:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.OUT,yychar,yychar+yytext().length()); }
					case -42:
						break;
					case 42:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.REV,yychar,yychar+yytext().length()); }
					case -43:
						break;
					case 43:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.ANY,yychar,yychar+yytext().length()); }
					case -44:
						break;
					case 44:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.WSTRING_LITERAL,yychar,yychar+yytext().length(), Convert.toString(yytext())); }
					case -45:
						break;
					case 45:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.CHAR_LITERAL,yychar,yychar+yytext().length(), new Character(yytext().charAt(1))); }
					case -46:
						break;
					case 46:
						{ /* System.out.println("Comment found: "+yytext()+"\n");*/ }
					case -47:
						break;
					case 47:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.LONG,yychar,yychar+yytext().length()); }
					case -48:
						break;
					case 48:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.ENUM,yychar,yychar+yytext().length()); }
					case -49:
						break;
					case 49:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.INST,yychar,yychar+yytext().length()); }
					case -50:
						break;
					case 50:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.AUTO,yychar,yychar+yytext().length()); }
					case -51:
						break;
					case 51:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.CASE,yychar,yychar+yytext().length()); }
					case -52:
						break;
					case 52:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.CHAR,yychar,yychar+yytext().length()); }
					case -53:
						break;
					case 53:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.BIND,yychar,yychar+yytext().length()); }
					case -54:
						break;
					case 54:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.TRUE,yychar,yychar+yytext().length()); }
					case -55:
						break;
					case 55:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR_LITERAL,yychar,yychar+yytext().length(), new Character(yytext().charAt(1)));}
					case -56:
						break;
					case 56:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.VOID,yychar,yychar+yytext().length()); }
					case -57:
						break;
					case 57:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.NULL, yychar,yychar+yytext().length()); }
					case -58:
						break;
					case 58:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.CHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }
					case -59:
						break;
					case 59:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.CHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }
					case -60:
						break;
					case 60:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.OCTET,yychar,yychar+yytext().length()); }
					case -61:
						break;
					case 61:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.UNION,yychar,yychar+yytext().length()); }
					case -62:
						break;
					case 62:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.USING,yychar,yychar+yytext().length()); }
					case -63:
						break;
					case 63:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.INOUT,yychar,yychar+yytext().length()); }
					case -64:
						break;
					case 64:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.FLOAT,yychar,yychar+yytext().length()); }
					case -65:
						break;
					case 65:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.FIXED,yychar,yychar+yytext().length()); }
					case -66:
						break;
					case 66:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.FRAME,yychar,yychar+yytext().length()); }
					case -67:
						break;
					case 67:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.CONST,yychar,yychar+yytext().length()); }
					case -68:
						break;
					case 68:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.SHORT,yychar,yychar+yytext().length()); }
					case -69:
						break;
					case 69:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR,yychar,yychar+yytext().length()); }
					case -70:
						break;
					case 70:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.FALSE,yychar,yychar+yytext().length()); }
					case -71:
						break;
					case 71:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }
					case -72:
						break;
					case 72:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }
					case -73:
						break;
					case 73:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.CHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }
					case -74:
						break;
					case 74:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.MODULE,yychar,yychar+yytext().length()); }
					case -75:
						break;
					case 75:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.DOUBLE,yychar,yychar+yytext().length()); }
					case -76:
						break;
					case 76:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.RAISES,yychar,yychar+yytext().length()); }
					case -77:
						break;
					case 77:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.STRUCT,yychar,yychar+yytext().length()); }
					case -78:
						break;
					case 78:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.STRING,yychar,yychar+yytext().length()); }
					case -79:
						break;
					case 79:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.SYSTEM,yychar,yychar+yytext().length()); }
					case -80:
						break;
					case 80:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.SWITCH,yychar,yychar+yytext().length()); }
					case -81:
						break;
					case 81:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }
					case -82:
						break;
					case 82:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR_LITERAL,yychar,yychar+yytext().length(), Convert.toCharacter(yytext())); }
					case -83:
						break;
					case 83:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.OBJECT,yychar,yychar+yytext().length()); }
					case -84:
						break;
					case 84:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.DEFAULT,yychar,yychar+yytext().length()); }
					case -85:
						break;
					case 85:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.TYPEDEF,yychar,yychar+yytext().length()); }
					case -86:
						break;
					case 86:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.SUBSUME,yychar,yychar+yytext().length()); }
					case -87:
						break;
					case 87:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.WSTRING,yychar,yychar+yytext().length()); }
					case -88:
						break;
					case 88:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.BOOLEAN,yychar,yychar+yytext().length()); }
					case -89:
						break;
					case 89:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.DELEGATE,yychar,yychar+yytext().length()); }
					case -90:
						break;
					case 90:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.UNSIGNED,yychar,yychar+yytext().length()); }
					case -91:
						break;
					case 91:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.READONLY,yychar,yychar+yytext().length()); }
					case -92:
						break;
					case 92:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.REQUIRE,yychar,yychar+yytext().length()); }
					case -93:
						break;
					case 93:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.PROTOCOL,yychar,yychar+yytext().length()); }
					case -94:
						break;
					case 94:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.PROPERTY,yychar,yychar+yytext().length()); }
					case -95:
						break;
					case 95:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.PROVIDE,yychar,yychar+yytext().length()); }
					case -96:
						break;
					case 96:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.SEQUENCE,yychar,yychar+yytext().length()); }
					case -97:
						break;
					case 97:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.EXCEPTION,yychar,yychar+yytext().length()); }
					case -98:
						break;
					case 98:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.INTERFACE,yychar,yychar+yytext().length()); }
					case -99:
						break;
					case 99:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.ATTRIBUTE,yychar,yychar+yytext().length()); }
					case -100:
						break;
					case 100:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.PRIMITIVE,yychar,yychar+yytext().length()); }
					case -101:
						break;
					case 101:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IMPLEMENTS,yychar,yychar+yytext().length()); }
					case -102:
						break;
					case 102:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.ARCHITECTURE,yychar,yychar+yytext().length()); }
					case -103:
						break;
					case 103:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.DOT_DOT,yychar,yychar+yytext().length()); }
					case -104:
						break;
					case 105:
						{ /* !!! co kdyz nic nepasuje */ System.out.println("NIC"); }
					case -105:
						break;
					case 106:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.DOT,yychar,yychar+yytext().length()); }
					case -106:
						break;
					case 107:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -107:
						break;
					case 108:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.INTEGER_LITERAL,yychar,yychar+yytext().length(), new Long(yytext())); }
					case -108:
						break;
					case 109:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.FLOATING_PT_LITERAL,yychar,yychar+yytext().length(), new Double(yytext())); }
					case -109:
						break;
					case 110:
						{ /* comments */ }
					case -110:
						break;
					case 111:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.CHAR_LITERAL,yychar,yychar+yytext().length(), new Character(yytext().charAt(1))); }
					case -111:
						break;
					case 112:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.WCHAR_LITERAL,yychar,yychar+yytext().length(), new Character(yytext().charAt(1)));}
					case -112:
						break;
					case 114:
						{ /* !!! co kdyz nic nepasuje */ System.out.println("NIC"); }
					case -113:
						break;
					case 115:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -114:
						break;
					case 116:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.INTEGER_LITERAL,yychar,yychar+yytext().length(), new Long(yytext())); }
					case -115:
						break;
					case 118:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -116:
						break;
					case 119:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.INTEGER_LITERAL,yychar,yychar+yytext().length(), new Long(yytext())); }
					case -117:
						break;
					case 121:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -118:
						break;
					case 122:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.INTEGER_LITERAL,yychar,yychar+yytext().length(), new Long(yytext())); }
					case -119:
						break;
					case 124:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -120:
						break;
					case 126:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -121:
						break;
					case 128:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -122:
						break;
					case 130:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -123:
						break;
					case 132:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -124:
						break;
					case 134:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -125:
						break;
					case 136:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -126:
						break;
					case 138:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -127:
						break;
					case 140:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -128:
						break;
					case 142:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -129:
						break;
					case 144:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -130:
						break;
					case 146:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -131:
						break;
					case 148:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -132:
						break;
					case 150:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -133:
						break;
					case 152:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -134:
						break;
					case 154:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -135:
						break;
					case 156:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -136:
						break;
					case 158:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -137:
						break;
					case 160:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -138:
						break;
					case 162:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -139:
						break;
					case 164:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -140:
						break;
					case 166:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -141:
						break;
					case 168:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -142:
						break;
					case 170:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -143:
						break;
					case 172:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -144:
						break;
					case 174:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -145:
						break;
					case 176:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -146:
						break;
					case 178:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -147:
						break;
					case 180:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -148:
						break;
					case 182:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -149:
						break;
					case 184:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -150:
						break;
					case 186:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -151:
						break;
					case 188:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -152:
						break;
					case 190:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -153:
						break;
					case 191:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -154:
						break;
					case 192:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -155:
						break;
					case 193:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -156:
						break;
					case 194:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -157:
						break;
					case 195:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -158:
						break;
					case 196:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -159:
						break;
					case 197:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -160:
						break;
					case 198:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -161:
						break;
					case 199:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -162:
						break;
					case 200:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -163:
						break;
					case 201:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -164:
						break;
					case 202:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -165:
						break;
					case 203:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -166:
						break;
					case 204:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -167:
						break;
					case 205:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -168:
						break;
					case 206:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -169:
						break;
					case 208:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -170:
						break;
					case 213:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -171:
						break;
					case 215:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -172:
						break;
					case 216:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -173:
						break;
					case 217:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -174:
						break;
					case 218:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -175:
						break;
					case 219:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -176:
						break;
					case 220:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -177:
						break;
					case 221:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -178:
						break;
					case 222:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -179:
						break;
					case 223:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -180:
						break;
					case 224:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -181:
						break;
					case 225:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -182:
						break;
					case 226:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -183:
						break;
					case 227:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -184:
						break;
					case 228:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -185:
						break;
					case 229:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -186:
						break;
					case 230:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -187:
						break;
					case 231:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -188:
						break;
					case 232:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -189:
						break;
					case 233:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -190:
						break;
					case 234:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -191:
						break;
					case 235:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -192:
						break;
					case 236:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -193:
						break;
					case 237:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -194:
						break;
					case 238:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -195:
						break;
					case 239:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -196:
						break;
					case 240:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -197:
						break;
					case 241:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -198:
						break;
					case 242:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -199:
						break;
					case 243:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -200:
						break;
					case 244:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -201:
						break;
					case 245:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -202:
						break;
					case 246:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -203:
						break;
					case 247:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -204:
						break;
					case 248:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -205:
						break;
					case 249:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -206:
						break;
					case 250:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -207:
						break;
					case 251:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -208:
						break;
					case 252:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -209:
						break;
					case 253:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -210:
						break;
					case 254:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -211:
						break;
					case 255:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -212:
						break;
					case 256:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -213:
						break;
					case 257:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -214:
						break;
					case 258:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -215:
						break;
					case 259:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -216:
						break;
					case 260:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -217:
						break;
					case 261:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -218:
						break;
					case 262:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -219:
						break;
					case 263:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -220:
						break;
					case 265:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -221:
						break;
					case 266:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -222:
						break;
					case 267:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -223:
						break;
					case 268:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -224:
						break;
					case 269:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -225:
						break;
					case 270:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -226:
						break;
					case 271:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -227:
						break;
					case 272:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -228:
						break;
					case 273:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -229:
						break;
					case 274:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -230:
						break;
					case 275:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -231:
						break;
					case 276:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -232:
						break;
					case 277:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -233:
						break;
					case 278:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -234:
						break;
					case 279:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -235:
						break;
					case 280:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -236:
						break;
					case 281:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -237:
						break;
					case 282:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -238:
						break;
					case 283:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -239:
						break;
					case 284:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -240:
						break;
					case 285:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -241:
						break;
					case 286:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -242:
						break;
					case 287:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -243:
						break;
					case 288:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -244:
						break;
					case 289:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -245:
						break;
					case 290:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -246:
						break;
					case 291:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -247:
						break;
					case 292:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -248:
						break;
					case 293:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -249:
						break;
					case 294:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -250:
						break;
					case 295:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -251:
						break;
					case 296:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -252:
						break;
					case 297:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -253:
						break;
					case 298:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -254:
						break;
					case 299:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -255:
						break;
					case 300:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -256:
						break;
					case 301:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -257:
						break;
					case 302:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -258:
						break;
					case 303:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -259:
						break;
					case 304:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -260:
						break;
					case 305:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -261:
						break;
					case 306:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -262:
						break;
					case 307:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -263:
						break;
					case 308:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -264:
						break;
					case 309:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -265:
						break;
					case 310:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -266:
						break;
					case 311:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -267:
						break;
					case 312:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -268:
						break;
					case 313:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -269:
						break;
					case 314:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -270:
						break;
					case 315:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -271:
						break;
					case 316:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -272:
						break;
					case 317:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -273:
						break;
					case 318:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -274:
						break;
					case 319:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -275:
						break;
					case 320:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -276:
						break;
					case 321:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -277:
						break;
					case 322:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -278:
						break;
					case 323:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -279:
						break;
					case 324:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -280:
						break;
					case 325:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -281:
						break;
					case 326:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -282:
						break;
					case 327:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -283:
						break;
					case 328:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -284:
						break;
					case 329:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -285:
						break;
					case 330:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -286:
						break;
					case 331:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -287:
						break;
					case 332:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -288:
						break;
					case 333:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -289:
						break;
					case 334:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -290:
						break;
					case 335:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -291:
						break;
					case 336:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -292:
						break;
					case 337:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -293:
						break;
					case 338:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -294:
						break;
					case 339:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -295:
						break;
					case 340:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -296:
						break;
					case 341:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -297:
						break;
					case 342:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -298:
						break;
					case 343:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -299:
						break;
					case 344:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -300:
						break;
					case 345:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -301:
						break;
					case 346:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -302:
						break;
					case 347:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -303:
						break;
					case 348:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -304:
						break;
					case 349:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -305:
						break;
					case 350:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -306:
						break;
					case 351:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -307:
						break;
					case 352:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -308:
						break;
					case 353:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -309:
						break;
					case 354:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -310:
						break;
					case 355:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -311:
						break;
					case 356:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -312:
						break;
					case 357:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -313:
						break;
					case 358:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -314:
						break;
					case 359:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -315:
						break;
					case 360:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -316:
						break;
					case 361:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -317:
						break;
					case 362:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -318:
						break;
					case 363:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -319:
						break;
					case 364:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -320:
						break;
					case 365:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -321:
						break;
					case 366:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -322:
						break;
					case 367:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -323:
						break;
					case 368:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -324:
						break;
					case 369:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -325:
						break;
					case 370:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -326:
						break;
					case 371:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -327:
						break;
					case 372:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -328:
						break;
					case 373:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -329:
						break;
					case 374:
						{ lineinfo.add(yyline,yychar); return new Symbol(sym.IDENTIFIER,yychar,yychar+yytext().length(), new String(yytext())); }
					case -330:
						break;
					default:
						yy_error(YY_E_INTERNAL,false);
					case -1:
					}
					yy_initial = true;
					yy_state = yy_state_dtrans[yy_lexical_state];
					yy_next_state = YY_NO_STATE;
					yy_last_accept_state = YY_NO_STATE;
					yy_mark_start();
					yy_this_accept = yy_acpt[yy_state];
					if (YY_NOT_ACCEPT != yy_this_accept) {
						yy_last_accept_state = yy_state;
						yy_mark_end();
					}
				}
			}
		}
	}
}
