/* $Id: ArchitectureDef.java,v 2.0 2002/02/15 13:55:04 hnetynka Exp $ */
package SOFA.SOFAnode.Made.TIR;
import java.rmi.RemoteException;

/** Interface for the architecture. */
public interface ArchitectureDef extends Contained, Container, CDLType {
  /** Returns <b>true</b> if architecture was declared <i>system</i> */
  public boolean is_system() throws RemoteException;
  
  /** Return frame which the architecture implements */
  public FrameDef frame() throws RemoteException;
  
  /** Create new inst object in this architecture. */
  public InstDef create_inst(String name, CDLType type, int mode) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new bind object in this architecture with default connector type (CSProcCall) */
  public BindDef create_bind(BindOperDef lhs, BindOperDef rhs, int mode) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new bind object in this architecture */
  public BindDef create_bind(BindOperDef lhs, BindOperDef rhs, int mode, String using) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new property in this architecture */
  public PropertyDef create_property(String name, CDLType type) throws RemoteException, TIRExceptCreate, TIRExceptLock;

  /** Create bind operand for provisions/requirments. */
  public BindOperProvReq create_bindoperprovreq() throws RemoteException, TIRExceptCreate;
  /** Create bind operand for subcomponent. */
  public BindOperSub create_bindopersub() throws RemoteException, TIRExceptCreate;
}
