/* $Id: Contained.java,v 2.0 2002/02/15 13:55:06 hnetynka Exp $ */
package SOFA.SOFAnode.Made.TIR;
import java.rmi.RemoteException;

/** The base interface <i>Contained</i> is extended by all <b>TIR</b> objects that are
    contained by <i>Container</i> objects.
*/
public interface Contained extends TIRObject {
  /** Returns identification of this <b>TIR</b> object. */
  public Identification get_identification() throws RemoteException;
  /** Add tag to the identification */
  public void tag(String t) throws RemoteException, TIRExceptCreate, TIRExceptLock; 

  /** Identifies the <i>Container</i> within which this object is defined. */
  public Container get_defined_in() throws RemoteException;
  /* Absolute name (ScopeName) of this object.      ----- moved to the Identification
  public AbsoluteName get_absolute_name() throws RemoteException; */
  /** Identifies containing repository (root of <b>TIR</b>). */
  public Container get_containing_repository() throws RemoteException;
}
