/* $Id: Identification.java,v 2.0 2002/02/15 13:55:10 hnetynka Exp $ */
package SOFA.SOFAnode.Made.TIR;
import java.rmi.Remote;
import java.rmi.RemoteException;

/** Identification of the <b>TIR</b> object. */
public interface Identification extends Remote {
  /** Tests if the identifications is equal. */
  public boolean is_equal(Identification id) throws RemoteException; 
  /** Tests if the identification is equal with name and version. */
  public boolean is_equal(String name, String version) throws RemoteException;
  /** Tests if the name in the identifications is equal. */
  public boolean is_name_equal(Identification id) throws RemoteException;
  /** Tests if the name in the identifications is equal. */
  public boolean is_name_equal(String name) throws RemoteException;
 
  /** Name */
  public String  name() throws RemoteException;
  /** Version */
  public String  version() throws RemoteException;
  /** test, if identification was created on local SOFAnode */
  public boolean is_local() throws RemoteException;
  /** Absolute name (ScopeName) of this object in scope of the concrete language. */
  public AbsoluteName absolute_name() throws RemoteException;
  /** Absolute name with language identification in the first item. */
  public AbsoluteName lang_absolute_name() throws RemoteException;
 
  /** Tags */
  public String[]  tag() throws RemoteException;
  /** Branch tag. Empty string identifies main branch. */
  public String  branchTag() throws RemoteException;
}
