/* $Id: ProtocolNullOperandDefImpl.java,v 2.1 2002/04/19 12:25:22 hnetynka Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.io.*;

public class ProtocolNullOperandDefImpl extends UnicastRemoteObject implements ProtocolNullOperandDef, TIRImplObject, SProtocolOperDef {
  ProtocolOperKind pok;
  DefinitionKindImpl defKindImpl;
  StateKindImpl stKindImpl;
  
  public ProtocolNullOperandDefImpl(int statekind) throws RemoteException {
    pok = new ProtocolOperKindImpl(ProtocolOperKind.pok_nulloperand);
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_ProtocolOper);
    stKindImpl = new StateKindImpl(statekind);
  }

  public ProtocolOperKind get_po_kind() throws RemoteException {
    return pok;
  }

  /* from interface TIRObject */
  public DefinitionKind get_def_kind() throws RemoteException {
    return (DefinitionKind) defKindImpl;
  }

  /* from interface TIRObject */
  public StateKind get_state() throws RemoteException {
    return (StateKind) stKindImpl;
  }

  public void save(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      st.curOutFile.writeInt(pok.value());
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't write in directory "+st.current+".");
    }
  }
  
  public void load(Storage st) throws RemoteException, TIRExceptStorage {
    /*
    try {

    } catch (IOException e) {
      throw new TIRExceptStorage("Can't read in directory "+st.current+".");
    }
    */
  }

  public void postLoad(RepositoryImpl r) throws RemoteException, TIRExceptStorage {
  }

  public boolean isNew() {
    return (stKindImpl.value()==StateKind.sk_work);
  }

  public void canCommit() throws RemoteException, TIRExceptCommit {;}

  public void doCommit(Container in, Repository rep) throws RemoteException {
    if (stKindImpl.value()==StateKind.sk_normal)
      return;
    stKindImpl.toNormal();
  }

  public void doAbort(long workId) throws RemoteException {}

  public String to_text() throws RemoteException {
    return "NULL";
  }
}
