/* $Id: SOFASystemClassLoader.java,v 1.2 2002/10/08 16:14:15 hnetynka Exp $ */
package SOFA.SOFAnode.Run;

import java.net.URL;
import java.net.URLConnection;
import java.net.MalformedURLException;
import java.io.InputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

/** SOFA sytem classloader - currently it is not used. It is a default system classloader. It is set by property 
  * <tt>java.system.class.loader</tt>.
  *
  * @author Petr Hnetynka
  */
public class SOFASystemClassLoader extends ClassLoader {
  
  URL url;
  ClassLoader cl;
  
  public SOFASystemClassLoader() {
    super();
    try {
      url = new URL(System.getProperty("sofa.tr.url","file:/sofa/tr/"));
    } catch (MalformedURLException e) {
      throw new SOFARuntimeException("MalformedURLException: "+e.getMessage(), e);
    }
  }
  
  public SOFASystemClassLoader(ClassLoader cl) {
    super(cl);
    this.cl = cl;
    try {
      url = new URL(System.getProperty("sofa.tr.url","file:/sofa/tr/"));
    } catch (MalformedURLException e) {
      throw new SOFARuntimeException("MalformedURLException: "+e.getMessage(), e);
    }
  }

  public Class findClass(String name) throws ClassNotFoundException {
//    System.out.println("!!!: "+name);
    byte[] b;
    b = loadClassData(name);
    Class ret = defineClass(name, b, 0, b.length);
//    System.out.println("!!! End: "+name);
    return ret;
  }

/*  protected Class loadClass(String name, boolean resolve) throws ClassNotFoundException {
    try {
      return super.loadClass(name, resolve);
    } catch (ClassNotFoundException e) {
      return cl.loadClass(name);
    }
  }*/

  private byte[] loadClassData(String name) throws ClassNotFoundException {
    java.util.StringTokenizer tok = new java.util.StringTokenizer(name, ".");
    StringBuffer pathWithoutVer = new StringBuffer();
    String nm = "";
    while (tok.hasMoreTokens()) {
      nm = tok.nextToken();
      pathWithoutVer.append(nm);
      pathWithoutVer.append("/");
    }
    pathWithoutVer.insert(0, url.toString());
    pathWithoutVer.setCharAt(pathWithoutVer.length()-1, '.');
    pathWithoutVer.append("class");
    URL defURL;
    try {
      defURL = new URL(pathWithoutVer.toString());
    } catch (MalformedURLException e) {
//      System.out.println("SYSLOADER Exception 1");
      throw new ClassNotFoundException("MalformedURLException: "+e.getMessage());
    }
    try {
      URLConnection con = defURL.openConnection();
      InputStream is = con.getInputStream();
      ByteArrayOutputStream bo = new ByteArrayOutputStream();
      int a = is.read();
      while (a != -1) {
        bo.write(a);
        a = is.read();
      }
      is.close();
      byte[] ar = bo.toByteArray();
      bo.close();
      return ar;
    } catch (IOException e) {
//      System.out.println("SYSLOADER Exception 2");
      throw new ClassNotFoundException("IOException: "+e.getMessage());
    }
  }
}
