/* $Id: ProtocolParallel.java,v 2.1 2002/04/27 13:49:46 visnovsky Exp $ */

package SOFA.SOFAnode.Util;

import java.util.*;

class ProtocolParallel extends ProtocolBinaryOperator {

    public ProtocolParallel( Protocol l, Protocol r ) {
	super( "|",l,r );
    }
    
    public Protocol Copy() {
	return new ProtocolParallel( left.Copy(), right.Copy() );
    }
    
    public Machine createMachine() {

        machineImpl m1 = (machineImpl)left.createMachine();
	machineImpl m2 = (machineImpl)right.createMachine();

              Debug.println(2,"This is createAndParallel of ");
	Debug.println(2,"Machine left:");
	((Printer)m1).Print(2);
	Debug.println(2,"Machine right:");
	((Printer)m2).Print(2);

        int n1,n2,n,i,j,t,e;
	int mapping [][] = new int[m1.nextID][m2.nextID];
        machineImpl m = new machineImpl( m1.nextID * m2.nextID);

        for( i = 0; i < m1.nextID; i++ )
	    for( j = 0; j < m2.nextID; j++ ) mapping[i][j] = m.addState();

	if( Debug.debug>1 ) {
        Debug.println(2, "Mapping:" );
        for( i = 0; i < m1.nextID; i++ )
	    for( j = 0; j < m2.nextID; j++ ) 
                Debug.println(2, "[" + i + "," + j + "] -> " + mapping[i][j]);
	}

	for( n1 = 0 ; n1< m1.nextID ; n1++ ) 
	    for( n2 = 0; n2 < m2.nextID; n2++ )
		for( t = 0 ; t < EdgeFactory.getActionTokensNum(); t ++ ){
		    if( m1.states[n1][t] != null )
			for( e = 0 ; e < m1.states[n1][t].used ; e++ )
			     m.addEdge( mapping[n1][n2],t,mapping[ m1.states[n1][t].data[e]][n2] );
		   
		    if( m2.states[n2][t] != null )
			for( e = 0 ; e < m2.states[n2][t].used ; e++ )
			     m.addEdge( mapping[n1][n2],t,mapping[n1][m2.states[n2][t].data[e]] );
		}

	m.SetStart( mapping[m1.Start()][m2.Start()]);

        Iterator k = m1.Stop().values().iterator();
        while( k.hasNext() ) {
            int n1i = ((Integer)k.next()).intValue();
	    Iterator l = m2.Stop().values().iterator();
	    while( l.hasNext() ) m.AddStop(mapping[n1i][((Integer)l.next()).intValue()]);
        }

        k = m1.Update().values().iterator();
        while( k.hasNext() ) {
            int n1i = ((Integer)k.next()).intValue();
	    Iterator l = m2.Update().values().iterator();
	    while( l.hasNext() ) m.addUpdateEdge(mapping[n1i][((Integer)l.next()).intValue()]);
        }

	m.Minimize();

        Debug.println(2,"createAndParallel: done - states:" + m.nextID);
	((Printer)m).Print(2);

        return m;
    }

    public Protocol getSameType( Object p1, Object p2 ) {
	return new ProtocolParallel( (Protocol)p1, (Protocol)p2 );
    }
}
